
USE [WaspTrackAsset]


PRINT ''
PRINT ''
PRINT '******************************'
PRINT 'Update tables  -- Create New Tables '
PRINT '******************************'
PRINT ''


if NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[asset_orders]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	PRINT '... asset_orders'
	CREATE TABLE [dbo].[asset_orders] (
		[asset_order] [int] NULL ,
		[asset_id] [int] NULL ,
		[asset_level] [int] NULL ,
		[root_id] [int] NULL ,
		[parent_id] [int] NULL ,
		[user_id] [int] NULL ,
		[date_updated] [datetime] NULL 
	) ON [PRIMARY]
END


if NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[asset_linking_indicator]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	PRINT '... asset_linking_indicator'
	CREATE TABLE [dbo].[asset_linking_indicator] (
		[linking_indicator] [int] NOT NULL ,
		[linking_description] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
		CONSTRAINT [PK_asset_linking_indicator] PRIMARY KEY  CLUSTERED 
		(
			[linking_indicator]
		)  ON [PRIMARY] 
	) ON [PRIMARY]
END


if NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[contracts]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	PRINT '... contracts'
	CREATE TABLE [dbo].[contracts] (
		[contract_id] [int] IDENTITY (1, 1) NOT NULL ,
		[contract_number] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
		[contract_description] [nvarchar] (1000) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[internal_contact] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[vendor_id] [int] NOT NULL ,
		[begin_date] [datetime] NULL ,
		[end_date] [datetime] NULL ,
		[num_licenses] [int] NOT NULL ,
		[is_software] [wtbool] NOT NULL ,
		[no_end_date] [wtbool] NOT NULL ,
		[record_status] [record_status_type] NOT NULL ,
		[company_id] [int] NOT NULL ,
		[usrdefdate1] [datetime] NULL ,
		[usrdefdate2] [datetime] NULL ,
		[usrdefdate3] [datetime] NULL ,
		[usrdefdate4] [datetime] NULL ,
		[usrdefdate5] [datetime] NULL ,
		[usrdefnumber1] [decimal](18, 0) NULL ,
		[usrdefnumber2] [decimal](18, 0) NULL ,
		[usrdefnumber3] [decimal](18, 0) NULL ,
		[usrdefnumber4] [decimal](18, 0) NULL ,
		[usrdefnumber5] [decimal](18, 0) NULL ,
		[usrdeftext1] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[usrdeftext2] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[usrdeftext3] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[usrdeftext4] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[usrdeftext5] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[usrdeftext6] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[usrdeftext7] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[usrdeftext8] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[usrdeftext9] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[usrdeftext10] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		CONSTRAINT [PK_contracts] PRIMARY KEY  CLUSTERED 
		(
			[contract_id]
		)  ON [PRIMARY] 
	) ON [PRIMARY]
END


if NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[asset_contract]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	PRINT '... asset_contract'
	CREATE TABLE [dbo].[asset_contract] (
		[asset_id] [int] NOT NULL ,
		[contract_id] [int] NOT NULL ,
		[record_added] [datetime] NOT NULL ,
		[record_removed] [datetime] NULL ,
		[record_status] [record_status_type] NOT NULL ,
		[company_id] [int] NOT NULL ,
		CONSTRAINT [PK_asset_contract] PRIMARY KEY  CLUSTERED 
		(
			[asset_id],
			[contract_id],
			[record_added]
		)  ON [PRIMARY] 
	) ON [PRIMARY]
END


if NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[maintenance_types]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	PRINT '... maintenance_types'
	CREATE TABLE [dbo].[maintenance_types] (
		[maintenance_id] [int] IDENTITY (1, 1) NOT NULL ,
		[maint_shortname_desc] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
		[date_updated] [datetime] NOT NULL ,
		[record_status] [record_status_type] NOT NULL ,
		[company_id] [int] NOT NULL ,
		CONSTRAINT [PK_maintenance_types] PRIMARY KEY  CLUSTERED 
		(
			[maintenance_id]
		)  ON [PRIMARY] 
	) ON [PRIMARY]
END


if NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[ui_settings]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	PRINT '... ui_settings'
	CREATE TABLE [dbo].[ui_settings] (
		[user_id] [int] NOT NULL ,
		[setting_name] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
		[setting_type] [varchar] (20) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
		[setting_value] [image] NULL ,
		CONSTRAINT [PK_ui_settings] PRIMARY KEY  CLUSTERED 
		(
			[user_id],
			[setting_name],
			[setting_type]
		)  ON [PRIMARY] 
	) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
END


GO





