
USE [WaspTrackAsset]

print ''
print ''
print '******************************'
print 'Update tables  -- Address '
print '******************************'
print ''

--SELECT * FROM dbo.syscolumns WHERE id = OBJECT_ID(N'[dbo].[address]')

if (((SELECT COUNT(*) FROM dbo.syscolumns WHERE id = OBJECT_ID(N'[dbo].[address]') AND NAME = 'table_name') = 0) OR
    ((SELECT COUNT(*) FROM dbo.syscolumns WHERE id = OBJECT_ID(N'[dbo].[address]') AND NAME = 'address_type_id') = 0) )
BEGIN
   	PRINT 'Updating Address table...'

	-- drop 'addressOld' if any
	if EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[addressOld]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	   drop table [dbo].[addressOld]
	   
	-- rename 'address' to 'addressOld'
	EXEC sp_rename N'[dbo].[address]', N'addressOld', N'object'
	ALTER TABLE [dbo].[addressOld] DROP CONSTRAINT [PK_address]
	
	-- drop 'address'
	if EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[address]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	BEGIN
	   DROP TABLE [dbo].[address]
	END

	-- create new 'address'
	CREATE TABLE [dbo].[address] (
		[address_id] [int] NOT NULL ,
		[table_name] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
		[address_type_id] [int] NOT NULL ,
		[record_type] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
		[address1] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[address2] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[address3] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[address4] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[city] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[state] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[postal_code] [varchar] (10) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[country] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[mail_stop] [varchar] (20) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[record_status] [record_status_type] NOT NULL ,
		CONSTRAINT [PK_address] PRIMARY KEY  CLUSTERED 
		(
			[address_id],
			[table_name],
			[address_type_id],
			[record_type]
		)  ON [PRIMARY] 
	) ON [PRIMARY]
	
	-- Insert data from the old address table to the new one with column handling
	-- Company Corporate
	INSERT INTO address (address_id, table_name, address_type_id, record_type, address1, address2, address3, address4, city, state, postal_code, country, mail_stop, 
	                      record_status)
	SELECT     address_id, 'company_info', 1, record_type, address1, address2, address3, address4, city, state, postal_code, country, mail_stop, 
	                      record_status
	FROM         dbo.addressOld where record_type='Company Corporate'
	
	-- Company Shipping
	INSERT INTO address (address_id, table_name, address_type_id, record_type, address1, address2, address3, address4, city, state, postal_code, country, mail_stop, 
	                      record_status)
	SELECT     address_id, 'company_info', 2, record_type, address1, address2, address3, address4, city, state, postal_code, country, mail_stop, 
	                      record_status
	FROM         dbo.addressOld where record_type='Company Shipping'

	-- Company Receiving
	INSERT INTO address (address_id, table_name, address_type_id, record_type, address1, address2, address3, address4, city, state, postal_code, country, mail_stop, 
	                      record_status)
	SELECT     address_id, 'company_info', 3, record_type, address1, address2, address3, address4, city, state, postal_code, country, mail_stop, 
	                      record_status
	FROM         dbo.addressOld where record_type='Company Receiving'
	

	-- Customer Billing
	INSERT INTO address (address_id, table_name, address_type_id, record_type, address1, address2, address3, address4, city, state, postal_code, country, mail_stop, 
	                      record_status)
	SELECT     address_id, 'customer', 1, 'Customer Billing', address1, address2, address3, address4, city, state, postal_code, country, mail_stop, 
	                      record_status
	FROM         dbo.addressOld where record_type='Customer Billing'
	
	-- Customer other
	INSERT INTO address (address_id, table_name, address_type_id, record_type, address1, address2, address3, address4, city, state, postal_code, country, mail_stop, 
	                      record_status)
	SELECT     address_id, 'customer', 100, LTRIM(REPLACE(record_type, 'customer', '')), address1, address2, address3, address4, city, state, postal_code, country, mail_stop, 
	                      record_status
	FROM         dbo.addressOld where    record_type like 'Customer%' and record_type <> 'Customer Billing'
	
	-- supplier Billing
	INSERT INTO address (address_id, table_name, address_type_id, record_type, address1, address2, address3, address4, city, state, postal_code, country, mail_stop, 
	                      record_status)
	SELECT     address_id, 'supplier', 1, record_type, address1, address2, address3, address4, city, state, postal_code, country, mail_stop, 
	                      record_status
	FROM         dbo.addressOld where record_type='Supplier Billing'  OR  record_type='Vendor Billing'
	
	-- supplier other
	INSERT INTO address (address_id, table_name, address_type_id, record_type, address1, address2, address3, address4, city, state, postal_code, country, mail_stop, 
	                      record_status)
	SELECT     address_id, 'supplier', 100, LTRIM(REPLACE(record_type, 'supplier', '')), address1, address2, address3, address4, city, state, postal_code, country, mail_stop, 
	                      record_status
	FROM         dbo.addressOld where   ( record_type like 'Supplier%' and record_type <> 'Supplier Billing' )
                                        
    INSERT INTO address (address_id, table_name, address_type_id, record_type, address1, address2, address3, address4, city, state, postal_code, country, mail_stop, 
	                      record_status)
	SELECT     address_id, 'supplier', 100, LTRIM(REPLACE(record_type, 'vendor', '')), address1, address2, address3, address4, city, state, postal_code, country, mail_stop, 
	                      record_status
	FROM         dbo.addressOld where   ( record_type like 'Vendor%' and record_type <> 'Vendor Billing' )

	
	-- manufacturer Billing
	INSERT INTO address (address_id, table_name, address_type_id, record_type, address1, address2, address3, address4, city, state, postal_code, country, mail_stop, 
	                      record_status)
	SELECT     address_id, 'manufacturer', 1, 'Manufacturer Billing', address1, address2, address3, address4, city, state, postal_code, country, mail_stop, 
	                      record_status
	FROM         dbo.addressOld where record_type='Manufacturer Billing'
	
	-- manufacturer other
	INSERT INTO address (address_id, table_name, address_type_id, record_type, address1, address2, address3, address4, city, state, postal_code, country, mail_stop, 
	                      record_status)
	SELECT     address_id, 'manufacturer', 100, right(record_type,len(record_type)-13), address1, address2, address3, address4, city, state, postal_code, country, mail_stop, 
	                      record_status
	FROM         dbo.addressOld where    record_type like 'Manufacturer%' and record_type <> 'Manufacturer Billing'
	
	-- employee Work Address
	INSERT INTO address (address_id, table_name, address_type_id, record_type, address1, address2, address3, address4, city, state, postal_code, country, mail_stop, 
	                      record_status)
	SELECT     address_id, 'employees', 1, 'Work Address', address1, address2, address3, address4, city, state, postal_code, country, mail_stop, 
	                      record_status
	FROM         dbo.addressOld where record_type='Employee Work Address'
	
	-- Employee other
	INSERT INTO address (address_id, table_name, address_type_id, record_type, address1, address2, address3, address4, city, state, postal_code, country, mail_stop, 
	                      record_status)
	SELECT     address_id, 'employees', 100, record_type, address1, address2, address3, address4, city, state, postal_code, country, mail_stop, 
	                      record_status
	FROM         dbo.addressOld where    record_type like 'Employee%' and record_type <> 'Employee Work Address'
	
	-- drop addressOld
	-- drop table [dbo].[addressOld]

END
ELSE
BEGIN
	PRINT 'Address table is already up-to-date.'
END

GO
