
USE [WaspTrackAsset]

PRINT ''
PRINT ''
PRINT '******************************'
PRINT 'Update tables  -- phone '
PRINT '******************************'
PRINT ''

--SELECT * FROM dbo.syscolumns WHERE id = OBJECT_ID(N'[dbo].[phone]')

if (((SELECT COUNT(*) FROM dbo.syscolumns WHERE id = OBJECT_ID(N'[dbo].[phone]') AND NAME = 'table_name') = 0) OR
    ((SELECT COUNT(*) FROM dbo.syscolumns WHERE id = OBJECT_ID(N'[dbo].[phone]') AND NAME = 'phone_type_id') = 0) )
BEGIN
	 
	-- drop phoneOld, if any  	
	if EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[phoneOld]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	   DROP TABLE [dbo].[phoneOld]
	   
	-- rename phone to phoneOld
	EXEC sp_rename N'[dbo].[phone]', N'phoneOld', N'object'
	ALTER TABLE [dbo].[phoneOld] DROP CONSTRAINT [PK_phone]

	-- drop phone table
	if EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[phone]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	BEGIN
	   drop table [dbo].[phone]
	END

	-- Create the new phone table
	CREATE TABLE [dbo].[phone] (
	[phone_id] [int] NOT NULL ,
	[table_name] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[phone_type_id] [int] NOT NULL ,
	[record_type] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[phone_number] [phone_type] NULL ,
	[extension] [varchar] (10) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[record_status] [record_status_type] NOT NULL ,
	CONSTRAINT [PK_phone] PRIMARY KEY  CLUSTERED 
		(
			[phone_id],
			[table_name],
			[phone_type_id],
			[record_type]
		)  ON [PRIMARY] 
	) ON [PRIMARY]

	-- Insert data FROM the old phone table to the new one with column handling
	-- Company Phone
	INSERT INTO phone (phone_id, table_name, phone_type_id, record_type, phone_number, extension, record_status)
	SELECT     phone_id, 'company_info', 1, record_type, phone_number, extension, record_status
	FROM         dbo.phoneOld WHERE record_type='Company Phone'

	-- Company Fax
	INSERT INTO phone (phone_id, table_name, phone_type_id, record_type, phone_number, extension, record_status)
	SELECT     phone_id, 'company_info', 2, record_type, phone_number, extension, record_status
	FROM         dbo.phoneOld WHERE record_type='Company Fax'

	-- Customer
	INSERT INTO phone (phone_id, table_name, phone_type_id, record_type, phone_number, extension, record_status)
	SELECT     phone_id, 'customer', 1, 'Phone', phone_number, extension, record_status
	FROM         dbo.phoneOld WHERE record_type='Customer Phone'

	INSERT INTO phone (phone_id, table_name, phone_type_id, record_type, phone_number, extension, record_status)
	SELECT     phone_id, 'customer', 2, 'Cell Phone', phone_number, extension, record_status
	FROM         dbo.phoneOld WHERE record_type='Customer Cell Phone'

	INSERT INTO phone (phone_id, table_name, phone_type_id, record_type, phone_number, extension, record_status)
	SELECT     phone_id, 'customer', 3, 'Fax', phone_number, extension, record_status
	FROM         dbo.phoneOld WHERE record_type='Customer Fax'

	INSERT INTO phone (phone_id, table_name, phone_type_id, record_type, phone_number, extension, record_status)
	SELECT     phone_id, 'customer', 4, 'Home Phone', phone_number, extension, record_status
	FROM         dbo.phoneOld WHERE record_type='Customer Home Phone'

	-- Manufacturer
	INSERT INTO phone (phone_id, table_name, phone_type_id, record_type, phone_number, extension, record_status)
	SELECT     phone_id, 'manufacturer', 1, 'Phone', phone_number, extension, record_status
	FROM         dbo.phoneOld WHERE record_type='Manufacturer Phone'

	INSERT INTO phone (phone_id, table_name, phone_type_id, record_type, phone_number, extension, record_status)
	SELECT     phone_id, 'manufacturer', 5, 'Fax', phone_number, extension, record_status
	FROM         dbo.phoneOld WHERE record_type='Manufacturer Fax'

	INSERT INTO phone (phone_id, table_name, phone_type_id, record_type, phone_number, extension, record_status)
	SELECT     phone_id, 'manufacturer', 2, 'Contact Cell', phone_number, extension, record_status
	FROM         dbo.phoneOld WHERE record_type='Manufacturer Contact Cell'

	INSERT INTO phone (phone_id, table_name, phone_type_id, record_type, phone_number, extension, record_status)
	SELECT     phone_id, 'manufacturer', 3, 'Contact Fax', phone_number, extension, record_status
	FROM         dbo.phoneOld WHERE record_type='Manufacturer Contact Fax'

	INSERT INTO phone (phone_id, table_name, phone_type_id, record_type, phone_number, extension, record_status)
	SELECT     phone_id, 'manufacturer', 4, 'Contact Work', phone_number, extension, record_status
	FROM         dbo.phoneOld WHERE record_type='Manufacturer Contact Work'

	-- Supplier
	INSERT INTO phone (phone_id, table_name, phone_type_id, record_type, phone_number, extension, record_status)
	SELECT     phone_id, 'supplier', 1, 'Phone', phone_number, extension, record_status
	FROM         dbo.phoneOld WHERE record_type='Vendor Phone' or record_type='Supplier Phone'

	INSERT INTO phone (phone_id, table_name, phone_type_id, record_type, phone_number, extension, record_status)
	SELECT     phone_id, 'supplier', 5, 'Fax', phone_number, extension, record_status
	FROM         dbo.phoneOld WHERE record_type='Supplier Fax' or record_type='Vendor Fax'

	INSERT INTO phone (phone_id, table_name, phone_type_id, record_type, phone_number, extension, record_status)
	SELECT     phone_id, 'supplier', 2, 'Contact Cell', phone_number, extension, record_status
	FROM         dbo.phoneOld WHERE record_type='Supplier Contact Cell' or record_type='Vendor Contact Cell'

	INSERT INTO phone (phone_id, table_name, phone_type_id, record_type, phone_number, extension, record_status)
	SELECT     phone_id, 'supplier', 3, 'Contact Fax', phone_number, extension, record_status
	FROM         dbo.phoneOld WHERE record_type='Supplier Contact Fax' or record_type='Vendor Contact Fax'

	INSERT INTO phone (phone_id, table_name, phone_type_id, record_type, phone_number, extension, record_status)
	SELECT     phone_id, 'supplier', 4, 'Contact Work', phone_number, extension, record_status
	FROM         dbo.phoneOld WHERE record_type='Supplier Contact Work' or record_type='Vendor Contact Work'

	-- Employee Work Phone
	INSERT INTO phone (phone_id, table_name, phone_type_id, record_type, phone_number, extension, record_status)
	SELECT     phone_id, 'employees', 1, 'Work Phone', phone_number, extension, record_status
	FROM         dbo.phoneOld WHERE record_type='Employee Work Phone'

	INSERT INTO phone (phone_id, table_name, phone_type_id, record_type, phone_number, extension, record_status)
	SELECT     phone_id, 'employees', 100, right(record_type, len(record_type)-9), phone_number, extension, record_status
	FROM         dbo.phoneOld WHERE record_type like 'Employee%' and  record_type <> 'Employee Work Phone'

END
ELSE
BEGIN
   PRINT 'Phone table is already up to date'
END  

GO	