
USE [WaspTrackAsset]

PRINT ''
PRINT ''
PRINT '******************************'
PRINT 'Insert default initial records '
PRINT '******************************'
PRINT ''


----------------------------------------------------
-- Table Name: address
----------------------------------------------------
if NOT EXISTS (select * from address where address_id=1 AND table_name='company_info' and address_type_id=1)
BEGIN
insert into address (address_id,table_name,address_type_id,record_type,address1,address2,address3,address4,city,state,postal_code,country,mail_stop,record_status) values (1,'company_info',1,'Company Corporate','','',null,null,'','','','',null,1);
END

if NOT EXISTS (select * from address where address_id=1 AND table_name='company_info' and address_type_id=3)
BEGIN
insert into address (address_id,table_name,address_type_id,record_type,address1,address2,address3,address4,city,state,postal_code,country,mail_stop,record_status) values (1,'company_info',3,'Company Receiving','','',null,null,'','','','',null,1);
END

if NOT EXISTS (select * from address where address_id=1 AND table_name='company_info' and address_type_id=2)
BEGIN
insert into address (address_id,table_name,address_type_id,record_type,address1,address2,address3,address4,city,state,postal_code,country,mail_stop,record_status) values (1,'company_info',2,'Company Shipping','','',null,null,'','','','',null,1);
END

if NOT EXISTS (select * from address where address_id=1 AND table_name='company_info' and address_type_id=4)
BEGIN
insert into address (address_id,table_name,address_type_id,record_type,address1,address2,address3,address4,city,state,postal_code,country,mail_stop,record_status) values (1,'company_info',4,'Company Billing','','',null,null,'','','','',null,1);
END
GO



----------------------------------------------------
-- Table Name: app_options
----------------------------------------------------

if NOT EXISTS (SELECT * FROM app_options WHERE code = '13')
BEGIN
	INSERT INTO app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) values (null,'13','text','Max Row Count','This is the maximum number of rows that will be displayed on most grids. Set this number to 0 to see all rows. The maximum can not be less than 100.','This is the maximum number of rows that will be displayed on most grids. Set this number to 0 to see all rows. The maximum can not be less than 100.','F','F','0','Support',1,1);
END	
else if NOT EXISTS (SELECT * FROM app_options WHERE code = '13' and record_status = 1 and company_id = 1)
BEGIN
	DELETE FROM app_options WHERE code = '13'
	INSERT INTO app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) values (null,'13','text','Max Row Count','This is the maximum number of rows that will be displayed on most grids. Set this number to 0 to see all rows. The maximum can not be less than 100.','This is the maximum number of rows that will be displayed on most grids. Set this number to 0 to see all rows. The maximum can not be less than 100.','F','F','0','Support',1,1);
END	

if NOT EXISTS (SELECT * FROM app_options WHERE code = '20')
BEGIN
   INSERT INTO app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) VALUES (null,'20','bool','Check For Software Updates','Turn this option on to automatically check for software update upon application startup. Must have internet connection for this to work.','Turn this option on to automatically check for software update upon application startup. Must have internet connection for this to work.','T','T',null,'Support',1,1);
END

DELETE FROM app_options WHERE code = '100'
INSERT INTO app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) VALUES (null,'100','text','Version','Application Version',null,'F','F','5.5',null,2,0);

DELETE FROM app_options WHERE code = '101'
insert into app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) values (null,'101','text','Database Version','Database Version',null,'F','F','5.5',null,2,0);

if EXISTS (SELECT * FROM app_options WHERE code = '4' and option_value = '01/01/2003')
BEGIN
	DELETE FROM app_options WHERE code = '4'
	INSERT INTO app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) VALUES (null,'4','date','Archive Transactions','Archive transactions prior to the date below :','Arhive transaction prior to this date','F','T','01/01/2005','Database',2,1);
END

if NOT EXISTS (SELECT * FROM app_options WHERE code = '22')
BEGIN
	insert into app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) values (null,'22','text','Archive Processed Mobile Data','Archive processed mobile data older than the number of the days listed below. Set this number to 0 if you do not wish to archive any processed mobile data. Valid values 90..360. Recommended 180.','Archive processed mobile data older than the number of the days listed below. Set this number to 0 if you do not wish to archive any processed mobile data. Valid values 90..360. Recommended 180.','F','F','180','Support',1,1);
END

if EXISTS (SELECT * FROM app_options WHERE code = '22' and option_value = '180')
BEGIN
	DELETE FROM app_options WHERE code = '22'
	INSERT INTO app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) values (null,'22','text','Archive Processed Mobile Data','Archive processed mobile data older than the number of the days listed below. Set this number to 0 if you do not wish to archive any processed mobile data. Valid values 90..360. Recommended 180.','Archive processed mobile data older than the number of the days listed below. Set this number to 0 if you do not wish to archive any processed mobile data. Valid values 90..360. Recommended 180.','F','F','180','Support',1,1);
END

if EXISTS (SELECT * FROM app_options WHERE code = '18')
BEGIN
	UPDATE app_options SET description = 'Allow duplicate Serial Numbers within the same Asset Type', tool_tip = 'Allow duplicate Serial Numbers within the same Asset Type' WHERE code = '18'
END
else
BEGIN
	insert into app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) values (null,'18','bool','Allow Duplicate Serial Numbers','Allow duplicate Serial Numbers within the same Asset Type','Allow duplicate Serial Numbers within the same Asset Type','F','T',null,'Asset',1,1);
END

if EXISTS (SELECT * FROM app_options WHERE code = '5')
BEGIN
	UPDATE app_options SET description = 'Automatically open the Create New screen when you enter an asset/site/location etc. that doesnt exist.  e.g. if you are creating a new asset and enter a location that is not in the database, the New Location screen will pop up automatically.', tool_tip = 'Automatically open the Create New screen when you enter an asset/site/location etc. that doesnt exist.  e.g. if you are creating a new asset and enter a location that is not in the database, the New Location screen will pop up automatically.' WHERE code = '5'
END


if NOT EXISTS (SELECT * FROM app_options WHERE code = '400')
BEGIN
	insert into app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) values (null,'400','text','SQL Server Backup Location','This is an existing directory on the PC/Server where the SQL database is installed in which user has permission to store the database backups. By default the Microsoft SQL Server backup directory is being used.','Database backup directory on the Machine where the database is installed','F','T','','Support',1,1);
END

if NOT EXISTS (SELECT * FROM app_options WHERE code = '401')
BEGIN
	insert into app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) values (null,'401','text','Last Backup Name','Name of the last backup','Name of the last backup','F','F','','Support',2,0);
END


----------------------------------------------------
-- Table Name: depreciation_methods
----------------------------------------------------

if (SELECT COUNT(type_id) FROM depreciation_methods WHERE type_id = 0) = 0
   INSERT INTO depreciation_methods (type_id,description) values (0,'None');
if (SELECT COUNT(type_id) FROM depreciation_methods WHERE type_id = 1) = 0
   INSERT INTO depreciation_methods (type_id,description) values (1,'Straight-Line');
if (SELECT COUNT(type_id) FROM depreciation_methods WHERE type_id = 2) = 0
   INSERT INTO depreciation_methods (type_id,description) values (2,'Double Declining Balance');
if (SELECT COUNT(type_id) FROM depreciation_methods WHERE type_id = 3) = 0
   INSERT INTO depreciation_methods (type_id,description) values (3,'150% Declining Balance');
if (SELECT COUNT(type_id) FROM depreciation_methods WHERE type_id = 4) = 0
   INSERT INTO depreciation_methods (type_id,description) values (4,'Declining Balance Custom');
if (SELECT COUNT(type_id) FROM depreciation_methods WHERE type_id = 5) = 0
   INSERT INTO depreciation_methods (type_id,description) values (5,'Sum-of-the-years''-digits');



----------------------------------------------------
-- Table Name: asset_linking_indicator
----------------------------------------------------

DELETE FROM asset_linking_indicator

INSERT INTO asset_linking_indicator (linking_indicator,linking_description) values (0,'  Not Linked');
INSERT INTO asset_linking_indicator (linking_indicator,linking_description) values (1,'  Has Parent');
INSERT INTO asset_linking_indicator (linking_indicator,linking_description) values (2,'  Has Child');
INSERT INTO asset_linking_indicator (linking_indicator,linking_description) values (3,'  Linked Both Ways');


----------------------------------------------------
-- Table Name: contracts
----------------------------------------------------
if ( SELECT COUNT(contract_id) FROM contracts WHERE contract_id = 0 ) = 0
BEGIN
   SET IDENTITY_INSERT [contracts] ON;
   INSERT INTO contracts (contract_id,contract_number,contract_description,internal_contact,vendor_id,begin_date,end_date,num_licenses,is_software,no_end_date,record_status,company_id,usrdefdate1,usrdefdate2,usrdefdate3,usrdefdate4,usrdefdate5,usrdefnumber1,usrdefnumber2,usrdefnumber3,usrdefnumber4,usrdefnumber5,usrdeftext1,usrdeftext2,usrdeftext3,usrdeftext4,usrdeftext5,usrdeftext6,usrdeftext7,usrdeftext8,usrdeftext9,usrdeftext10) values (0,' ',null,null,0,null,null,0,'F','F',1,1,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null);
   SET IDENTITY_INSERT [contracts] OFF;
END
GO


----------------------------------------------------
-- Table Name: form
----------------------------------------------------
if (SELECT COUNT(form_id) FROM form WHERE form_id = 29) = 0
   INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) values (29,'users','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 32) = 0	
   INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) values (32,'Contracts','T',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10200) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) values (10200,'PPC - Main','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10201) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) values (10201,'PPC - New','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10202) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) values (10202,'PPC - Edit','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10203) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) values (10203,'PPC - Audit','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10204) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) values (10204,'PPC - CheckIn','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10205) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) values (10205,'PPC - CheckOut','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10206) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) values (10206,'PPC - Dispose','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10207) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) values (10207,'PPC - Move','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10208) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) values (10208,'PPC - Maint','F',1,1);
----------------------------------------------------
-- Table Name: form_field_meta
----------------------------------------------------
-- v4.0.2 already has users (form 29) entries, so delete and reinsert
DELETE FROM form_field_meta WHERE form_id = 26
DELETE FROM form_field_meta WHERE form_id = 27 AND field not like 'usrdef%'
DELETE FROM form_field_meta WHERE form_id = 29
DELETE FROM form_field_meta WHERE form_id = 32 AND field not like 'usrdef%'
DELETE FROM form_field_meta WHERE form_id = 100
DELETE FROM form_field_meta WHERE form_id = 90000
DELETE FROM form_field_meta WHERE form_id >= 2000 and form_id <= 2200
DELETE FROM form_field_meta WHERE form_id >= 10200 and form_id <= 10208

UPDATE form_field_meta SET db_field = 'code' WHERE form_id = 30 and field = 'code'

-- form 7 (location, site field
UPDATE form_field_meta SET field_length=50, default_field_length=50 WHERE form_id = 7 AND field = 'site' AND control = 'Label'

-- form 17
if (SELECT COUNT(form_id) FROM form_field_meta WHERE form_id = 17 and control = 'Label' and field = 'maint_type') = 0
	INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (17,'Label','maint_type',null,null,'&Type','Maintenance Type','T','F','F',30,'&Type','Maintenance Type','T','F',30,null,null,null,1,1,'T','1','1');

-- form 26
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (26,'Label','asset_life_months',null,'asset_life_months','Asset Life Months:','Asset Depreciation Life Months','T','N','F',4,'Asset Life Months:','Asset Depreciation Life Months','T','N',4,null,null,null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (26,'Label','asset_life_years',null,'asset_life_years','Asset Life Years:','Asset Depreciation Life Years','T','N','F',4,'Asset Life Years:','Asset Depreciation Life Years','T','N',4,null,null,null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (26,'List Form Name','Class',null,null,'Depreciation Class','Asset Depreciation Class List',null,null,'F',null,'Depreciation Class','Asset Depreciation Class List',null,null,null,null,null,null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (26,'Label','class_name',null,'class_name','Name:','Depreciation Class Name','T','T','T',50,'Name:','Depreciation Class Name','T','T',50,null,null,null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (26,'Label','depreciation_custom_percent',null,'depreciation_custom_percent','Custom Percentage:','Custom Percentage to apply to the depreciation method','T','T','T',3,'Custom Percentage:','Custom Percentage to apply to the depreciation method','T','T',3,null,null,null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (26,'Label','depreciation_method',null,'depreciation_method','Depreciation Method:','Asset Deprecation Method','T','T','T',50,'Depreciation Method:','Asset Deprecation Method','T','T',50,null,null,null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (26,'Label','depreciation_period',null,null,'Depreciation Period:','Asset Deprecation Period','T','T','F',4,'Depreciation Period:','Asset Deprecation Period','T','T',4,null,null,null,2,1,'T','1','1');
insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (26,'Label','deprec_to_salvage',null,'deprec_to_salvage','Fully depreciate to salvage value','Adjust the final year depreciation to ensure asset value reaches its specified salvage value. (This only applies to double or custom declining method)','T','F','T',1,'Fully depreciate to salvage value','Adjust the final year depreciation to ensure asset value reaches its specified salvage value. (This only applies to double or custom declining method)','T','F',1,null,null,null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (26,'Label','lblClass',null,'class_name','Name:','Depreciation Class Name','T','F','T',50,'Name:','Depreciation Class Name','T','F',50,null,null,null,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (26,'Label','lblDepMethod',null,'depreciation_method','Depreciation Method:','Asset Depreciation Class Method','T','F','T',4,'Depreciation Method:','Asset Depreciation Class Method','T','F',4,null,null,null,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (26,'Label','lblDepPeriod',null,null,'Depreciation Period:','Asset Depreciation Period','T','F','F',4,'Depreciation Period:','Asset Depreciation Period','T','F',4,null,null,null,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (26,'Label','lblLife',null,null,'&Life:','Depreciation Class Life','T','F','T',4,'&Life:','Depreciation Class Life','T','F',4,null,null,null,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (26,'Label','lblMonths',null,null,'Months','Depreciation Class Life Months','T','F','F',4,'Months','Depreciation Class Life Months','T','F',4,null,null,null,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (26,'Label','lblYears',null,null,'Years','Depreciation Class Life Years','T','F','F',4,'Years','Depreciation Class Life Years','T','F',4,null,null,null,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (26,'Label','rbMonths',null,null,'Years','Depreciation in Months','T','F','F',4,'Years','Depreciation in Months','T','F',4,null,null,null,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (26,'Label','rbYears',null,null,'Years','Depreciation in Years','T','F','F',4,'Years','Depreciation in Years','T','F',4,null,null,null,2,1,'T','1','1');

-- form 27
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'List Form Name','Asset',null,null,'Asset','Asset List',null,null,'F',null,'Asset','Asset List',null,null,null,null,null,null,1,1,'T','0','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','asset_contains',null,'child_id','Child Asset(s): ','Select the child assets.','T','F','T',100,'Child Asset(s): ','Select the child assets.','T','F',100,null,'F',null,1,1,'F','1','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','asset_part_of',null,'parent_id','Parent Asset: ','Enter the parent asset tag.','T','F','T',100,'Parent Asset: ','Enter the parent asset tag.','T','F',100,null,'F',null,1,1,'F','1','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','asset_tag',null,'asset_tag','Asset Tag:','Enter AssetTag in this field. Asset Tag must be unique.','T','T','T',30,'Asset Tag:','Enter AssetTag in this field. Asset Tag must be unique.','T','T',30,null,'F',null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','assigned_to',null,null,'Assigned to:','Maintenance assignee.','T','F','T',30,'Assigned to:','Maintenance assignee.','T','F',30,null,'F',null,1,1,'T','1','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','cadescription',null,'category','Category:','Category of the asset type.','T','F','T',50,'Category:','Category of the asset type.','T','F',50,null,'F',null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','check_to_audit',null,'','','','F','F','F',1,'','','F','F',1,null,'F',null,1,1,'F','0','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','checkout_duration',null,'checkout_duration','Checkout Lengt&h:','The default number of days a customer/employee can have this asset checked out. Used to populate the default Check Out time.','T','F','T',4,'Checkout Lengt&h:','The default number of days a customer/employee can have this asset checked out. Used to populate the default Check Out time.','T','F',4,null,'F',null,1,1,'T','0','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','class_info',null,null,'Class Info:','Information about the asset type''s class.','T','F','F',50,'Class Info:','Information about the asset type''s class.','T','F',50,null,'F',null,1,1,'T','1','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','class_name',null,'class_name','Depreciation Class:','Name of the asset type''s class.','T','F','F',50,'Depreciation Class:','Name of the asset type''s class.','T','F',50,null,'F',null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','code',null,'code','Department Code:','Department WHERE asset is located.','T','F','T',30,'Department Code:','Department WHERE asset is located.','T','F',30,null,'F',null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','condition',null,'condition','Condition:','Condition of asset.','T','F','T',30,'Condition:','Condition of asset.','T','F',30,null,'F',null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','current_depreciation',null,'current_depreciation','Current Depreciation:','Current amount of depreciation.','T','F','T',8,'Current Depreciation:','Current amount of depreciation.','T','F',8,null,'F',null,1,1,'T','1','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','days_of_week_fri',null,null,'Fri','Select day of week.','T','F','T',7,'Fri','Select day of week.','T','F',7,null,'F',null,1,1,'T','0','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','days_of_week_mon',null,null,'Mon','Select day of week.','T','F','T',7,'Mon','Select day of week.','T','F',7,null,'F',null,1,1,'T','0','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','days_of_week_sat',null,null,'Sat','Select day of week.','T','F','T',7,'Sat','Select day of week.','T','F',7,null,'F',null,1,1,'T','0','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','days_of_week_sun',null,null,'Sun','Select day of week.','T','F','T',7,'Sun','Select day of week.','T','F',7,null,'F',null,1,1,'T','0','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','days_of_week_thu',null,null,'Thu','Select day of week.','T','F','T',7,'Thu','Select day of week.','T','F',7,null,'F',null,1,1,'T','0','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','days_of_week_tue',null,null,'Tue','Select day of week.','T','F','T',7,'Tue','Select day of week.','T','F',7,null,'F',null,1,1,'T','0','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','days_of_week_wed',null,null,'Wed','Select day of week.','T','F','T',7,'Wed','Select day of week.','T','F',7,null,'F',null,1,1,'T','0','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','depreciated_value',null,'depreciated_value','Book Value:','Cost of asset less depreciation.','T','F','T',8,'Book Value:','Cost of asset less depreciation.','T','F',8,null,'F',null,1,1,'T','1','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','depreciation_begin_date',null,'depreciation_begin_date','Depreciation Begin Date:','Date depreciation of asset started.','T','F','T',8,'Depreciation Begin Date:','Date depreciation of asset started.','T','F',8,null,'F',null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','description',null,'description','Asset Type Description:','Description of Asset Type.','T','F','F',255,'Asset Type Description:','Description of Asset Type.','T','F',255,null,'F',null,1,1,'T','1','2');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','is_checked_out',null,'is_checked_out','Checked Out:','Checked out status.','T','F','T',1,'Checked Out:','Checked out status.','T','F',1,null,'F',null,1,1,'T','1','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','item_info',null,null,'Asset Type Information:','Information about the Asset Type.','T','F','F',0,'Asset Type Information:','Information about the Asset Type.','T','F',0,null,'F',null,1,1,'T','1','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','item_number',null,'item_number','Asset Type:','Type of Asset','T','T','T',30,'Asset Type:','Type of Asset','T','T',30,null,'F',null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','last_depreciation_date',null,'last_depreciation_date','Last Depreciation Date:','Date of last depreciation calculation.','T','F','T',8,'Last Depreciation Date:','Date of last depreciation calculation.','T','F',8,null,'F',null,1,1,'T','1','0');
insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','last_audit_date',null,'last_audit_date','Last Audit Date:','Date of last audit is conducted on this asset.','T','F','T',8,'Last Audit Date:','Date of last audit is conducted on this asset.','T','F',8,null,'F',null,1,1,'T','1','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','linking_indicator',null,'linking_indicator','Linking','Indicates whether the asset is linked to other assets','T','F','F',1,'Linking','Indicates whether the asset is linked to other assets','T','F',1,null,'F',null,1,1,'F','0','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','location',null,'location','Location:','Enter the location of the asset.','T','T','T',30,'Location:','Enter the location of the asset.','T','T',30,null,'F',null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','maintain_asset',null,null,'Maintain Asset:','Check if asset needs maintenance.','T','F','T',0,'Maintain Asset:','Check if asset needs maintenance.','T','F',0,null,'F',null,1,1,'T','1','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','maintain_tasks',null,null,'Instructions:','Instructions for performing maintenance.','T','F','T',1000,'Instructions:','Instructions for performing maintenance.','T','F',1000,null,'F',null,1,1,'T','1','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','maintenance_date',null,null,null,'Maintenance date.','T','F','F',8,null,'Maintenance date.','T','F',8,null,'F',null,1,1,'T','1','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','maintenance_start_dt',null,null,'Maint Start:','Maintenance start date.','T','F','T',8,'Maint Start:','Maintenance start date.','T','F',8,null,'F',null,1,1,'T','1','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','maintenance_start_dy',null,null,'Maint Start:','Maintenance start date.','T','F','T',8,'Maint Start:','Maintenance start date.','T','F',8,null,'F',null,1,1,'T','1','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','maintenance_start_mo',null,null,'Maint Start:','Maintenance start date.','T','F','T',8,'Maint Start:','Maintenance start date.','T','F',8,null,'F',null,1,1,'T','1','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','maintenance_start_wk',null,null,'Maint Start:','Maintenance start date.','T','F','T',8,'Maint Start:','Maintenance start date.','T','F',8,null,'F',null,1,1,'T','1','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','manufacturer',null,'manufacturer','Manufacturer:','Manufacturer of item.','T','F','F',50,'Manufacturer:','Manufacturer of item.','T','F',50,null,'F',null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','model',null,'model','Model:','Model of item.','T','F','F',50,'Model:','Model of item.','T','F',50,null,'F',null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','monthly_date',null,null,'of every','Date of month.','T','F','F',0,'of every','Date of month.','T','F',0,null,'F',null,1,1,'T','1','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','monthly_day',null,null,'of every','Day of month.','T','F','F',0,'of every','Day of month.','T','F',0,null,'F',null,1,1,'T','1','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','monthly_days',null,null,'of every','Day of week.','T','F','F',0,'of every','Day of week.','T','F',0,null,'F',null,1,1,'T','1','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','monthly_type_date',null,null,'Day','Maintenance on specified date in month.','T','F','T',0,'Day','Maintenance on specified date in month.','T','F',0,null,'F',null,1,1,'T','1','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','monthly_type_day',null,null,null,'Maintenance on specified day in month.','T','F','F',0,null,'Maintenance on specified day in month.','T','F',0,null,'F',null,1,1,'T','1','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','note_text',null,'note_text','Additional Info:','Additional information about asset.','T','F','T',32767,'Additional Info:','Additional information about asset.','T','F',32767,null,'F',null,1,1,'F','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','occurs_daily',null,null,'Daily','Maintain daily.','T','F','T',0,'Daily','Maintain daily.','T','F',0,null,'F',null,1,1,'T','1','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','occurs_date',null,null,'Date','Maintenance on specified date.','T','F','T',0,'Date','Maintenance on specified date.','T','F',0,null,'F',null,1,1,'T','1','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','occurs_every_day',null,null,'day(s)','Daily maintenance frequency.','T','F','T',4,'day(s)','Daily maintenance frequency.','T','F',4,null,'F',null,1,1,'T','1','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','occurs_every_mo',null,null,'month(s)','Number of months.','T','F','F',0,'month(s)','Number of months.','T','F',0,null,'F',null,1,1,'T','1','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','occurs_every_week',null,null,'week(s) on:','Weekly maintenance frequency.','T','F','T',4,'week(s) on:','Weekly maintenance frequency.','T','F',4,null,'F',null,1,1,'T','1','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','occurs_monthly',null,null,'Monthly','Maintain monthly.','T','F','T',0,'Monthly','Maintain monthly.','T','F',0,null,'F',null,1,1,'T','1','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','occurs_weekly',null,null,'Weekly','Maintain weekly.','T','F','T',0,'Weekly','Maintain weekly.','T','F',0,null,'F',null,1,1,'T','1','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','po',null,'po','Purchase Order:','Purchase order number.','T','F','T',30,'Purchase Order:','Purchase order number.','T','F',30,null,'F',null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','purchase_cost',null,'purchase_cost','Purchase Cost:','Asset purchase cost.','T','F','T',8,'Purchase Cost:','Asset purchase cost.','T','F',8,null,'F',null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','purchase_date',null,'purchase_date','Purchase Date:','Date asset was purchased.','T','F','T',8,'Purchase Date:','Date asset was purchased.','T','F',8,null,'F',null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','salvage_value',null,'salvage_value','Salvage Value:','Salvage value of asset.','T','F','T',8,'Salvage Value:','Salvage value of asset.','T','F',8,null,'F',null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','schedule_date',null,'schedule_date','Next Date:','Date of next maintenance.','T','F','T',8,'Next Date:','Date of next maintenance.','T','F',8,null,'F',null,1,1,'0','1','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','Select',null,null,'Select',null,'T','F','F',0,'Select',null,'T','F',0,null,'F',null,1,1,'T','1','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','serial_number',null,'serial_number','Serial No:','Serial number of asset.','T','F','T',30,'Serial No:','Serial number of asset.','T','F',30,null,'F',null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','should_depreciate',null,'should_depreciate','Depreciate Asset:','Check to depreciate asset.','T','F','T',1,'Depreciate Asset:','Check to depreciate asset.','T','F',1,null,'F',null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','site_name',null,'site_name','Site:','Site WHERE asset is located.','T','T','T',50,'Site:','Site WHERE asset is located.','T','T',50,null,'F',null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','total_depreciation',null,'total_depreciation','Total Depreciation:','Total amount of depreciation.','T','F','T',8,'Total Depreciation:','Total amount of depreciation.','T','F',8,null,'F',null,1,1,'T','1','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','transact_as_whole',null,'transact_as_whole','Transact As Whole','Indicates whether all assets that this one contains are transacted together as a group.','T','F','F',1,'Transact As Whole','Indicates whether all assets that this one contains are transacted together as a group.','T','F',1,null,'F',null,1,1,'F','0','0');
--INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','usrdefdate1',null,'usrdefdate1','Custom &Date 1:','Enter a custom date.','F','F','T',20,'Custom &Date 1:','Enter a custom date.','F','F',20,null,'T',null,1,1,'T','1','1');
--INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','usrdefdate2',null,'usrdefdate2','Custom D&ate 2:','Enter a custom date.','F','F','T',20,'Custom D&ate 2:','Enter a custom date.','F','F',20,null,'T',null,1,1,'T','1','1');
--INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','usrdefdate3',null,'usrdefdate3','Custom Da&te 3:','Enter a custom date.','F','F','T',20,'Custom Da&te 3:','Enter a custom date.','F','F',20,null,'T',null,1,1,'T','1','1');
--INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','usrdefdate4',null,'usrdefdate4','Custom Dat&e 4:','Enter a custom date.','F','F','T',20,'Custom Dat&e 4:','Enter a custom date.','F','F',20,null,'T',null,1,1,'T','1','1');
--INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','usrdefdate5',null,'usrdefdate5','Custom Date &5:','Enter a custom date.','F','F','T',20,'Custom Date &5:','Enter a custom date.','F','F',20,null,'T',null,1,1,'T','1','1');
--INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','usrdefnumber1',null,'usrdefnumber1','Custom &Number 1:','Enter a custom number.','F','F','T',20,'Custom &Number 1:','Enter a custom number.','F','F',20,null,'T',null,1,1,'T','1','1');
--INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','usrdefnumber2',null,'usrdefnumber2','Custom N&umber 2:','Enter a custom number.','F','F','T',20,'Custom N&umber 2:','Enter a custom number.','F','F',20,null,'T',null,1,1,'T','1','1');
--INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','usrdefnumber3',null,'usrdefnumber3','Custom Nu&mber 3:','Enter a custom number.','F','F','T',20,'Custom Nu&mber 3:','Enter a custom number.','F','F',20,null,'T',null,1,1,'T','1','1');
--INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','usrdefnumber4',null,'usrdefnumber4','Custom Num&ber 4:','Enter a custom number.','F','F','T',20,'Custom Num&ber 4:','Enter a custom number.','F','F',20,null,'T',null,1,1,'T','1','1');
--INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','usrdefnumber5',null,'usrdefnumber5','Custom Numbe&r 5:','Enter a custom number.','F','F','T',20,'Custom Numbe&r 5:','Enter a custom number.','F','F',20,null,'T',null,1,1,'T','1','1');
--INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','usrdeftext1',null,'usrdeftext1','Custom Text &1:','Enter custom text.','F','F','T',100,'Custom Text &1:','Enter custom text.','F','F',100,null,'T',null,1,1,'T','1','1');
--INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','usrdeftext10',null,'usrdeftext10','Custom Text 1&0:','Enter custom text.','F','F','T',100,'Custom Text 1&0:','Enter custom text.','F','F',100,null,'T',null,1,1,'T','1','1');
--INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','usrdeftext2',null,'usrdeftext2','Custom Text &2:','Enter custom text.','F','F','T',100,'Custom Text &2:','Enter custom text.','F','F',100,null,'T',null,1,1,'T','1','1');
--INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','usrdeftext3',null,'usrdeftext3','Custom Text &3:','Enter custom text.','F','F','T',100,'Custom Text &3:','Enter custom text.','F','F',100,null,'T',null,1,1,'T','1','1');
--INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','usrdeftext4',null,'usrdeftext4','Custom Text &4:','Enter custom text.','F','F','T',100,'Custom Text &4:','Enter custom text.','F','F',100,null,'T',null,1,1,'T','1','1');
--INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','usrdeftext5',null,'usrdeftext5','Custom Text &5:','Enter custom text.','F','F','T',100,'Custom Text &5:','Enter custom text.','F','F',100,null,'T',null,1,1,'T','1','1');
--INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','usrdeftext6',null,'usrdeftext6','Custom Text &6:','Enter custom text.','F','F','T',100,'Custom Text &6:','Enter custom text.','F','F',100,null,'T',null,1,1,'T','1','1');
--INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','usrdeftext7',null,'usrdeftext7','Custom Text &7:','Enter custom text.','F','F','T',100,'Custom Text &7:','Enter custom text.','F','F',100,null,'T',null,1,1,'T','1','1');
--INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','usrdeftext8',null,'usrdeftext8','Custom Text &8:','Enter custom text.','F','F','T',100,'Custom Text &8:','Enter custom text.','F','F',100,null,'T',null,1,1,'T','1','1');
--INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','usrdeftext9',null,'usrdeftext9','Custom Text &9:','Enter custom text.','F','F','T',100,'Custom Text &9:','Enter custom text.','F','F',100,null,'T',null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','warranty_begin_date',null,'warranty_begin_date','Warranty Begin:','Warranty start date.','T','F','T',8,'Warranty Begin:','Warranty start date.','T','F',8,null,'F',null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','warranty_end_date',null,'warranty_end_date','Warranty End:','Warranty end date.','T','F','T',8,'Warranty End:','Warranty end date.','T','F',8,null,'F',null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (27,'Label','warranty_provider',null,'warranty_provider','Warranty Provider:','Name of warranty provider.','T','F','T',50,'Warranty Provider:','Name of warranty provider.','T','F',50,null,'F',null,1,1,'T','1','1');

-- form 29
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (29,'Label','first_name',null,'first_name','First Name:','','T','F','F',50,'First Name:','','T','F',50,null,null,null,1,1,'F','0','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (29,'Label','last_name',null,'last_name','Last Name:',null,'T','F','F',50,'Last Name:',null,'T','F',50,null,null,null,1,1,'F','0','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (29,'Label','title',null,'title','Title:',null,'T','F','F',50,'Title:',null,'T','F',50,null,null,null,1,1,'F','0','0');


-- form 32
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (32,'Label','asset_count',null,'asset_count','Asset Count','The number of assets associated with this contract.','T','F','T',15,'Asset Count','The number of assets associated with this contract.','T','F',15,null,null,null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (32,'Label','begin_date',null,'begin_date','Begin Date','The date this contract was established.','T','F','T',20,'Begin Date','The date this contract was established.','T','F',20,null,null,null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (32,'Label','contract_description',null,'contract_description','Description','A short description of this contract.','T','F','T',1000,'Description','A short description of this contract.','T','F',1000,null,null,null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (32,'Label','contract_number',null,'contract_number','Contract Number','The number used to identify this contract. (Can be alphanumeric)','T','T','T',255,'Contract Number','The number used to identify this contract. (Can be alphanumeric)','T','T',255,null,null,null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (32,'List Form Name','Contracts',null,null,'Contracts','**','T','F','T',0,'Contracts','**','T','F',0,null,null,null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (32,'Label','end_date',null,'end_date','End Date','The date this contract expires.','T','F','T',20,'End Date','The date this contract expires.','T','F',20,null,null,null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (32,'Label','internal_contact',null,'internal_contact','Internal Contact','The person in charge of this contract.','T','F','T',255,'Internal Contact','The person in charge of this contract.','T','F',255,null,null,null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (32,'Label','is_software',null,'is_software','Software','If this contract represents a software contract or license agrement, check this box.','T','F','T',2,'Software','If this contract represents a software contract or license agrement, check this box.','T','F',2,null,null,null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (32,'Label','no_end_date',null,'no_end_date','No End Date','If the contract does not expire, check this box.','F','F','F',2,'No End Date','If the contract does not expire, check this box.','F','F',2,null,null,null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (32,'Label','num_licenses',null,'num_licenses','Licenses','The number of licenses represented by this contract.','T','F','T',20,'Licenses','The number of licenses represented by this contract.','T','F',20,null,null,null,1,1,'T','1','1');
--INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (32,'Label','usrdefdate1',null,'usrdefdate1','Custom &Date 1',null,'F','F','T',null,'Custom &Date 1',null,'F','F',null,null,null,null,1,1,'T','1','1');
--INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (32,'Label','usrdefdate2',null,'usrdefdate2','Custom D&ate 2',null,'F','F','T',null,'Custom D&ate 2',null,'F','F',null,null,null,null,1,1,'T','1','1');
--INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (32,'Label','usrdefdate3',null,'usrdefdate3','Custom Da&te 3',null,'F','F','T',null,'Custom Da&te 3',null,'F','F',null,null,null,null,1,1,'T','1','1');
--INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (32,'Label','usrdefdate4',null,'usrdefdate4','Custom Dat&e 4',null,'F','F','T',null,'Custom Dat&e 4',null,'F','F',null,null,null,null,1,1,'T','1','1');
--INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (32,'Label','usrdefdate5',null,'usrdefdate5','Custom Date &5',null,'F','F','T',null,'Custom Date &5',null,'F','F',null,null,null,null,1,1,'T','1','1');
--INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (32,'Label','usrdefnumber1',null,'usrdefnumber1','Custom &Number 1',null,'F','F','T',null,'Custom &Number 1',null,'F','F',null,null,null,null,1,1,'T','1','1');
--INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (32,'Label','usrdefnumber2',null,'usrdefnumber2','Custom N&umber 2',null,'F','F','T',null,'Custom N&umber 2',null,'F','F',null,null,null,null,1,1,'T','1','1');
--INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (32,'Label','usrdefnumber3',null,'usrdefnumber3','Custom Nu&mber 3',null,'F','F','T',null,'Custom Nu&mber 3',null,'F','F',null,null,null,null,1,1,'T','1','1');
--INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (32,'Label','usrdefnumber4',null,'usrdefnumber4','Custom Num&ber 4',null,'F','F','T',null,'Custom Num&ber 4',null,'F','F',null,null,null,null,1,1,'T','1','1');
--INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (32,'Label','usrdefnumber5',null,'usrdefnumber5','Custom Numbe&r 5',null,'F','F','T',null,'Custom Numbe&r 5',null,'F','F',null,null,null,null,1,1,'T','1','1');
--INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (32,'Label','usrdeftext1',null,'usrdeftext1','Custom Text &1',null,'F','F','T',null,'Custom Text &1',null,'F','F',null,null,null,null,1,1,'T','1','1');
--INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (32,'Label','usrdeftext10',null,'usrdeftext10','Custom Text &10',null,'F','F','T',null,'Custom Text &10',null,'F','F',null,null,null,null,1,1,'T','1','1');
--INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (32,'Label','usrdeftext2',null,'usrdeftext2','Custom Text &2',null,'F','F','T',null,'Custom Text &2',null,'F','F',null,null,null,null,1,1,'T','1','1');
--INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (32,'Label','usrdeftext3',null,'usrdeftext3','Custom Text &3',null,'F','F','T',null,'Custom Text &3',null,'F','F',null,null,null,null,1,1,'T','1','1');
--INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (32,'Label','usrdeftext4',null,'usrdeftext4','Custom Text &4',null,'F','F','T',null,'Custom Text &4',null,'F','F',null,null,null,null,1,1,'T','1','1');
--INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (32,'Label','usrdeftext5',null,'usrdeftext5','Custom Text &5',null,'F','F','T',null,'Custom Text &5',null,'F','F',null,null,null,null,1,1,'T','1','1');
--INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (32,'Label','usrdeftext6',null,'usrdeftext6','Custom Text &6',null,'F','F','T',null,'Custom Text &6',null,'F','F',null,null,null,null,1,1,'T','1','1');
--INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (32,'Label','usrdeftext7',null,'usrdeftext7','Custom Text &7',null,'F','F','T',null,'Custom Text &7',null,'F','F',null,null,null,null,1,1,'T','1','1');
--INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (32,'Label','usrdeftext8',null,'usrdeftext8','Custom Text &8',null,'F','F','T',null,'Custom Text &8',null,'F','F',null,null,null,null,1,1,'T','1','1');
--INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (32,'Label','usrdeftext9',null,'usrdeftext9','Custom Text &9',null,'F','F','T',null,'Custom Text &9',null,'F','F',null,null,null,null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (32,'Label','vendor_id',null,'vendor_id','Vendor ID','The vendor id that sold or maintains this contract.','F','F','T',20,'Vendor ID','The vendor id that sold or maintains this contract.','F','F',20,null,null,null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (32,'Label','vendor_name',null,'vendor_name','Vendor Name','The name of the vendor that sold or  maintains this contract.','T','F','T',255,'Vendor Name','The name of the vendor that sold or  maintains this contract.','T','F',255,null,null,null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (32,'Label','vendor_number',null,'vendor_number','Vendor Number','The number used to identify the vendor that sold or maintains this contract.','T','F','T',20,'Vendor Number','The number used to identify the vendor that sold or maintains this contract.','T','F',20,null,null,null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (32,'Label','vendor_combo',null,'vendor_combo','Vendor','The name of the vendor that sold or  maintains this contract.','T','F','T',255,'Vendor','The name of the vendor that sold or  maintains this contract.','T','F',255,null,null,null,1,1,'F','0','0');


-- form 100
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Admin Advanced Find','FindAdvanced','17','Advanced Find',null,'T',null,'T',null,'Advanced Find',null,'T',null,null,7,null,101,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Admin Find','Find','7','Find',null,'T',null,'F',null,'Find',null,'T',null,null,2,null,1,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Admin New','New','8','New',null,'T',null,'F',null,'New',null,'T',null,null,2,null,3,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Admin New Asset','New','18','Admin New Asset',null,'T',null,'T',null,'Admin New Asset',null,'T',null,null,8,null,200,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Admin New Class','Class','136','Admin New Class',null,'T',null,'T',null,'Admin New Class',null,'T',null,null,8,null,208,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Admin New Customer','New','19','Admin New Customer',null,'T',null,'T',null,'Admin New Customer',null,'T',null,null,8,null,201,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Admin New Department','Dempartment','20','Admin New Department',null,'T',null,'T',null,'Admin New Department',null,'T',null,null,8,null,202,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Admin New Employee','Employee','23','Admin New Employee',null,'T',null,'T',null,'Admin New Employee',null,'T',null,null,8,null,205,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Admin New Location','New_Location','21','Admin New Location',null,'T',null,'T',null,'Admin New Location',null,'T',null,null,8,null,203,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Admin New Manufacturer','New_Manufacturer','24','Admin New Manufacturer',null,'T',null,'T',null,'Admin New Manufacturer',null,'T',null,null,8,null,207,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Admin New Site','New_Site','22','Admin New Site',null,'T',null,'T',null,'Admin New Site',null,'T',null,null,8,null,204,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Admin Simple Find','Find','16','Simple Find',null,'T',null,'T',null,'Simple Find',null,'T',null,null,7,null,100,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Administration',null,'2','Administration','Click to view the Administration menu','T',null,'F',null,'Administration','Click to view the Administration menu','T',null,null,0,null,3,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','App New',null,'170','New','Click to view the New menu','T',null,'T',null,'New','Click to view the New menu','T',null,null,0,null,7,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Asset Advanced Find','FindAdvanced','53','Advanced Find','Click to launch the advanced find','T',null,'T',null,'Advanced Find','Click to launch the advanced find','T',null,null,44,null,101,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Asset Find','Find','44','Find','Click to find information','T',null,'F',null,'Find','Click to find information','T',null,null,1,null,10,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Asset Management',null,'1','Asset Management','Click to view the Asset Management menu','T',null,'F',null,'Asset Management','Click to view the Asset Management menu','T',null,null,0,null,1,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Asset Mgmt List','Lists_Asset','201','List Assets','Click to view the asset list','T',null,'T',null,'List Assets','Click to view the asset list','T',null,null,1,null,1,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Asset Mgmt New','Asset','202','New Asset','Create a new asset','T',null,'T',null,'New Asset','Create a new asset','T',null,null,1,null,2,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Asset New Asset','Asset','54','Asset','Click to create a new asset','T',null,'T',null,'Asset','Click to create a new asset','T',null,null,170,null,1,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Asset New Class','Class','131','Depreciation Class','Click to create a new depreciation class','T',null,'T',null,'Depreciation Class','Click to create a new depreciation class','T',null,null,170,null,6,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Asset New Contract','Contract','83','Contract/License','Click to create a new contract/software license','T',null,'T',null,'Contract/License','Click to create a new contract/software license','T',null,null,170,null,3,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Asset New Customer','New','55','Customer','Click to create a new customer','T',null,'T',null,'Customer','Click to create a new customer','T',null,null,170,null,4,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Asset New Department','Department','56','Department','Click to create a new department','T',null,'T',null,'Department','Click to create a new department','T',null,null,170,null,5,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Asset New Employee','Employee','59','Employee','Click to create a new employee','T',null,'T',null,'Employee','Click to create a new employee','T',null,null,170,null,7,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Asset New Item','Item','61','Asset Type','Click to create a new asset type','T',null,'T',null,'Asset Type','Click to create a new asset type','T',null,null,170,null,2,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Asset New Location','New_Location','57','Location','Click to create a new location','T',null,'T',null,'Location','Click to create a new location','T',null,null,170,null,8,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Asset New Manufacturer','New_Manufacturer','60','Manufacturer','Click to create a new manufacturer','T',null,'T',null,'Manufacturer','Click to create a new manufacturer','T',null,null,170,null,9,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Asset New Site','New_Site','58','Site','Click to create a new site','T',null,'T',null,'Site','Click to create a new site','T',null,null,170,null,10,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Asset New Supplier','Supplier','82','Vendor','Click to create a new vendor','T',null,'T',null,'Vendor','Click to create a new vendor','T',null,null,170,null,11,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Asset Reports','Reports_64','85','Asset Reports',null,'T',null,'T',null,'Asset Reports',null,'T',null,null,4,null,1,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Asset Simple Find','Find','52','Simple Find','Click to launch the simple find','T',null,'F',null,'Simple Find','Click to launch the simple find','T',null,null,44,null,100,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'List Form Name','asset_transactions',null,null,'Asset Transactions',null,null,null,'T',null,'Asset Transactions',null,null,null,null,null,null,null,1,1,'0','0','0');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Assets by Employee','Reports','92','Assets by Employee',null,'T',null,'T',null,'Assets by Employee',null,'T',null,null,4,null,102,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Assets by Location','Reports','91','Assets by Location',null,'T',null,'T',null,'Assets by Location',null,'T',null,null,4,null,101,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Assets by Serial Number','Reports','93','Assets by Serial Number',null,'T',null,'T',null,'Assets by Serial Number',null,'T',null,null,4,null,103,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Assets by Site','Reports','90','Assets by Site',null,'T',null,'T',null,'Assets by Site',null,'T',null,null,4,null,100,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Audit','Audit','51','Audit','Click to audit/verify an assets location','T',null,'T',null,'Audit','Click to audit/verify an assets location','T',null,null,1,null,6,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Audit History','Reports','96','Audit History',null,'T',null,'F',null,'Audit History',null,'T',null,null,4,null,300,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Audit Reports','Reports','87','Audit Reports',null,'T',null,'T',null,'Audit Reports',null,'T',null,null,4,null,3,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Audit Unreconciled','Reports','97','Audit Unreconciled',null,'T',null,'T',null,'Audit Unreconciled',null,'T',null,null,4,null,301,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Backup','Backup','122','Backup','Click to backup the MobileAsset database','T',null,'F',null,'Backup','Click to backup the MobileAsset database','T',null,null,6,null,1,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Calculate Depreciation','Depreciate','200','Calculate Depreciation','Click to calcuate depreciation for assets','T',null,'T',null,'Calculate Depreciation','Click to calcuate depreciation for assets','T',null,null,1,null,9,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Change Password','Security','126','Change Password','Click to change password','T',null,'T',null,'Change Password','Click to change password','T',null,null,12,null,2,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Check-In','CheckIn','49','Check-In','Click to check-in a previously checked-out asset','T',null,'T',null,'Check-In','Click to check-in a previously checked-out asset','T',null,null,1,null,5,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Check-In By Asset','CheckIn','69','Check-In By Asset Tag',null,'T',null,'T',null,'Check-In By Asset Tag',null,'T',null,null,49,null,1,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Check-In By Customer','CheckIn','70','Check-In By Customer',null,'T',null,'T',null,'Check-In By Customer',null,'T',null,null,49,null,2,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Check-In By Employee','CheckIn','71','Check-In By Employee',null,'T',null,'T',null,'Check-In By Employee',null,'T',null,null,49,null,3,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Check-Out','CheckOut','50','Check-Out','Click to check-out an asset to an employee or customer','T',null,'T',null,'Check-Out','Click to check-out an asset to an employee or customer','T',null,null,1,null,4,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Check-Out Reports','Reports','86','Check-Out Reports',null,'T',null,'T',null,'Check-Out Reports',null,'T',null,null,4,null,2,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Check-Out To Customer','CheckOut','72','Check-Out To Customer',null,'T',null,'T',null,'Check-Out To Customer',null,'T',null,null,50,null,1,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Check-Out To Employee','CheckOut','73','Check-Out To Employee',null,'T',null,'T',null,'Check-Out To Employee',null,'T',null,null,50,null,2,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Checked Out By Customer','Reports','94','Checked Out By Customer',null,'T',null,'T',null,'Checked Out By Customer',null,'T',null,null,4,null,200,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Checked Out Overdue','Reports','95','Checked Out Overdue',null,'T',null,'T',null,'Checked Out Overdue',null,'T',null,null,4,null,201,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Company Information','Company_Info','9','Company Information','Click to edit your company information','T',null,'T',null,'Company Information','Click to edit your company information','T',null,null,2,null,1,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Customize Names','Customize_Names','13','Customize Names','Click to change the names of menus','T',null,'T',null,'Customize Names','Click to change the names of menus','T',null,null,2,null,5,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Database Management','Database_Management','6','Database Management','Click to  backup or restore a MobileAsset database','T',null,'F',null,'Database Management','Click to  backup or restore a MobileAsset database','T',null,null,2,null,2,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Dispose','Dispose','47','Dispose','Click to dispose/remove an asset','T',null,'T',null,'Dispose','Click to dispose/remove an asset','T',null,null,1,null,7,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Dispose By Location','Dispose','62','Dispose By Location',null,'T',null,'T',null,'Dispose By Location',null,'T',null,null,47,null,400,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Dispose By Serial Number','Dispose','63','Dispose By Serial Number',null,'T',null,'T',null,'Dispose By Serial Number',null,'T',null,null,47,null,401,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Dispose By Site','Dispose','64','Dispose By Site',null,'T',null,'T',null,'Dispose By Site',null,'T',null,null,47,null,402,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'List Form Name','employees',null,null,'Employees','Employee List',null,null,'F',null,'Employees','Employee List',null,null,null,null,null,null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Export Wizard','Export_Wizard','37','Export Wizard','Click to export data to an external file','T',null,'F',null,'Export Wizard','Click to export data to an external file','T',null,null,11,null,501,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Import / Export Wizard','ImportExport_Wizard','11','Import / Export Wizard','Click to import or export data FROM or to an external file','T',null,'T',null,'Import / Export Wizard','Click to import or export data FROM or to an external file','T',null,null,2,null,4,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Import Wizard','Import_Wizard','36','Import Wizard','Click to import data FROM an external file','T',null,'F',null,'Import Wizard','Click to import data FROM an external file','T',null,null,11,null,500,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Labels',null,'3','Labels','Click to view Labels','T',null,'F',null,'Labels','Click to view Labels','T',null,null,0,null,4,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','License Management','License_Management','14','License Management','Click to manage user and mobile device licenses','T',null,'T',null,'License Management','Click to manage user and mobile device licenses','T',null,null,2,null,8,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','List Assets','Lists_Asset','26','Assets','Click to view assets','T',null,'T',null,'Assets','Click to view assets','T',null,null,10,null,1,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','List Classes','Lists_Class','135','Depreciation Classes','Click to view classes','T',null,'T',null,'Depreciation Classes','Click to view classes','T',null,null,10,null,6,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','List Contracts','Lists_Contract','35','Contracts/Licenses','Click to view contracts/software licenses','T',null,'T',null,'Contracts/Licenses','Click to view contracts/software licenses','T',null,null,10,null,3,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','List Customers','Lists_Customer','28','Customers','Click to view customers','T',null,'T',null,'Customers','Click to view customers','T',null,null,10,null,4,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','List Departments','Lists_Department','29','Departments','Click to view departments','T',null,'T',null,'Departments','Click to view departments','T',null,null,10,null,5,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','List Employees','Lists_Employee','32','Employees','Click to view employees','T',null,'T',null,'Employees','Click to view employees','T',null,null,10,null,7,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','List Item','Lists_AssetType','137','Asset Types','Click to view asset types','T',null,'T',null,'Asset Types','Click to view asset types','T',null,null,10,null,2,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','List Locations','Lists_Location','30','Locations','Click to view locations','T',null,'T',null,'Locations','Click to view locations','T',null,null,10,null,8,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','List Manufacturers','Lists_Manuf','34','Manufacturers','Click to view manufacturers','T',null,'T',null,'Manufacturers','Click to view manufacturers','T',null,null,10,null,9,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','List Sites','Lists_Site','31','Sites','Click to view sites','T',null,'T',null,'Sites','Click to view sites','T',null,null,10,null,10,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','List Suppliers','Lists_Vendor','33','Vendors','Click to view vendors','T',null,'T',null,'Vendors','Click to view vendors','T',null,null,10,null,11,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Lists',null,'10','List Forms','Click to view lists of the data in your system.','T','T','F',30,'List Forms','Click to view lists of the data in your system.','T','T',30,0,null,2,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Location By Company','Reports','99','Location By Company',null,'T',null,'T',null,'Location By Company',null,'T',null,null,4,null,401,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Location By Site','Reports','98','Location By Site',null,'T',null,'T',null,'Location By Site',null,'T',null,null,4,null,400,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Location Reports','Reports','88','Location Reports',null,'T',null,'T',null,'Location Reports',null,'T',null,null,4,null,4,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Login As Different User','Security','127','Login As Different User','Click to logoff of MobileAsset','T',null,'T',null,'Login As Different User','Click to logoff of MobileAsset','T',null,null,12,null,6,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Maintenance','Maintenance','160','Maintenance Entry','Click to enter maintenance for assets','T',null,'T',null,'Maintenance Entry','Click to enter maintenance for assets','T',null,null,1,null,8,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Mobe By Asset Number','Move','67','Move By Site',null,'T',null,'T',null,'Move By Site',null,'T',null,null,48,null,1,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Mobe By Department','Move','67','Move By Cost Center',null,'T',null,'T',null,'Move By Cost Center',null,'T',null,null,48,null,4,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Mobility',null,'5','Mobility','Click to view the Mobility menu','T',null,'F',null,'Mobility','Click to view the Mobility menu','T',null,null,0,null,6,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Move','Move','48','Move','Click to move an asset FROM one location to another','T',null,'T',null,'Move','Click to move an asset FROM one location to another','T',null,null,1,null,3,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Move By Location','Move','65','Move By Location',null,'T',null,'T',null,'Move By Location',null,'T',null,null,48,null,2,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Move By Serial Number','Move','66','Move By Serial Number',null,'T',null,'T',null,'Move By Serial Number',null,'T',null,null,48,null,3,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Options','Options','15','Options','Click to set MobileAsset options','T',null,'T',null,'Options','Click to set MobileAsset options','T',null,null,2,null,6,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','PDA','PDA','105','Palm PDA','Click to view the palm device menu','T',null,'T',null,'Palm PDA','Click to view the palm device menu','T',null,null,5,null,1,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','PDA Create Database','PDACreate','111','Create PDA Database','Click to create a palm database','T',null,'T',null,'Create PDA Database','Click to create a palm database','T',null,null,105,null,102,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','PDA Customize PDA Interface','PDA_Customize','110','Customize PDA Interface',null,'T',null,'T',null,'Customize PDA Interface',null,'T',null,null,105,null,101,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','PDA PDA to PC','PDATo','113','PDA PDA to PC',null,'T',null,'T',null,'PDA PDA to PC',null,'T',null,null,105,null,104,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','PDA Setup','PDA_Setup','109','PDA Setup','Click to setup a palm device','T',null,'T',null,'PDA Setup','Click to setup a palm device','T',null,null,105,null,100,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','PDA Synchronize','PDA_Synchronize','112','Synchronize PDA','Click to  synchronize the palm device with the pc','T',null,'T',null,'Synchronize PDA','Click to  synchronize the palm device with the pc','T',null,null,105,null,103,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Pocket PC','PKPC','140','Windows Mobile / CE','Click to view the Windows Mobile / CE device menu','T',null,'T',null,'Windows Mobile / CE','Click to view the Windows Mobile / CE device menu','T',null,null,5,null,2,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Pocket PC Create Database','PKPC_Create','143','Create Windows Mobile / CE Database','Click to create a Windows Mobile / CE database','T',null,'T',null,'Create Windows Mobile / CE Database','Click to create a Windows Mobile / CE database','T',null,null,140,null,102,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Pocket PC Customize Labels','PKPC_Customize','142','Customize Windows Mobile / CE Interface',null,'T',null,'T',null,'Customize Windows Mobile / CE Interface',null,'T',null,null,140,null,101,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Pocket PC Setup','PKPC_Setup','141','Windows Mobile / CE Setup','Click to setup a Windows Mobile / CE device','T',null,'T',null,'Windows Mobile / CE Setup','Click to setup a Windows Mobile / CE device','T',null,null,140,null,100,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Pocket PC Synchronize','PKPC_Synchronize','144','Synchronize Windows Mobile / CE','Click to synchronize the Windows Mobile / CE device with the pc','T',null,'T',null,'Synchronize Windows Mobile / CE','Click to  synchronize the Windows Mobile / CE device with the pc','T',null,null,140,null,103,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Process Mobile Device Data','ProcessMobileData','108','Process Mobile Device Data','Click to process mobile device data','T',null,'T',null,'Process Mobile Device Data','Click to process mobile device data','T',null,null,5,null,4,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Rename Add','Add','38','Rename Add',null,'T',null,'T',null,'Rename Add',null,'T',null,null,13,null,1,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Rename Audit','Audit','39','Rename Audit','Click to rename the Audit menu','T',null,'T',null,'Rename Audit','Click to rename the Audit menu','T',null,null,13,null,2,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Rename Check-In','CheckIn','40','Rename Check-In','Click to rename the Check-In menu','T',null,'T',null,'Rename Check-In','Click to rename the Check-In menu','T',null,null,13,null,3,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Rename Check-Out','CheckOut','41','Rename Check-Out','Click to rename the Check-Out menu','T',null,'T',null,'Rename Check-Out','Click to rename the Check-Out menu','T',null,null,13,null,4,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Rename Dispose','Dispose','42','Rename Dispose','Click to rename the Dispose menu','T',null,'T',null,'Rename Dispose','Click to rename the Dispose menu','T',null,null,13,null,5,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Rename Move','Move','43','Rename Move','Click to rename the Move menu','T',null,'T',null,'Rename Move','Click to rename the Move menu','T',null,null,13,null,6,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Reports',null,'4','Reports','Click to view Reports','T',null,'F',null,'Reports','Click to view Reports','T',null,null,0,null,5,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Reset All Labels','Reset_All_Labels','125','Reset All Field Names','Click to reset all the field names and menu to their defaults','T',null,'T',null,'Reset All Field Names','Click to reset all the field names and menu to their defaults','T',null,null,13,null,7,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Restore','Restore','123','Restore','Click to restore a previous backup of MobileAsset','T',null,'T',null,'Restore','Click to restore a previous backup of MobileAsset','T',null,null,6,null,2,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Security','Security','12','Security','Click to manage the security of users.','T','T','F',30,'Security','Click to manage the security of users.','T','T',30,2,null,3,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Select Site','SetDefaultWorkingSite','200','Set Default Working Site','Click to set default source and destination sites.','T','T','T',null,'Set Default Working Site','Click to set default source and destination sites.','T','T',null,2,null,5,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Set Seed Value','Set_Seed_Value','203','Set Seed Number','Click to change the Asset Tag next value','T',null,'T',null,'Set Seed Number','Click to change the Asset Tag next value','T',null,null,2,null,7,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Transaction - Add','Reports','100','Transaction - Add',null,'T',null,'T',null,'Transaction - Add',null,'T',null,null,4,null,500,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Transaction - Check-In','Reports','104','Transaction - Check-In',null,'T',null,'T',null,'Transaction - Check-In',null,'T',null,null,4,null,504,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Transaction - Check-Out','Reports','103','Transaction - Check-Out',null,'T',null,'T',null,'Transaction - Check-Out',null,'T',null,null,4,null,503,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Transaction - Dispose','Reports','101','Transaction - Dispose',null,'T',null,'T',null,'Transaction - Dispose',null,'T',null,null,4,null,501,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Transaction - Move','Reports','102','Transaction - Move',null,'T',null,'T',null,'Transaction - Move',null,'T',null,null,4,null,502,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Transaction Reports','Reports','89','Transaction Reports',null,'T',null,'T',null,'Transaction Reports',null,'T',null,null,4,null,5,2,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','User Management','Security','130','User Manager','Click to add/edit users security','T',null,'T',null,'User Manager','Click to add/edit users security','T',null,null,12,null,1,1,1,'T','1','1');



-- start of 102xx
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10200,null,'audit asset',null,null,'Audit','Audit',null,null,'T',null,'Audit','Audit',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10200,null,'checkin',null,null,'Check-In','Check-In',null,null,'T',null,'Check-In','Check-In',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10200,null,'checkout',null,null,'Check-Out','Check-Out',null,null,'T',null,'Check-Out','Check-Out',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10200,null,'dispose',null,null,'Dispose','Dispose',null,null,'T',null,'Dispose','Dispose',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10200,null,'edit asset',null,null,'Edit Asset','Edit Asset',null,null,'T',null,'Edit Asset','Edit Asset',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10200,null,'maintenance',null,null,'Maintenance','Maintenance',null,null,'T',null,'Maintenance','Maintenance',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10200,null,'move asset',null,null,'Move','Move',null,null,'T',null,'Move','Move',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10200,null,'new asset',null,null,'New Asset','New Asset',null,null,'T',null,'New Asset','New Asset',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10201,null,'asset_tag',null,null,'Asset Tag:','Asset Tag',null,null,'T',null,'Asset Tag:','Asset Tag',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10201,null,'category',null,null,'Category:','Category',null,null,'T',null,'Category:','Category',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10201,null,'class',null,null,'Depr.Class:','Class',null,null,'T',null,'Depr.Class:','Class',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10201,null,'co_duration',null,null,'C.O.Duration:','C.O.Duration',null,null,'T',null,'C.O.Duration:','C.O.Duration',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10201,null,'contains',null,null,'Child Assets:','Child Assets',null,null,'T',null,'Child Assets:','Child Assets',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10201,null,'department',null,null,'Department:','Department',null,null,'T',null,'Department:','Department',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10201,null,'desc',null,null,'Description:','Description',null,null,'T',null,'Description:','Description',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10201,null,'description',null,null,'Description:','Description',null,null,'T',null,'Description:','Description',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10201,null,'item_id',null,null,'Asset Type:','Asset Type',null,null,'T',null,'Asset Type:','Asset Type',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10201,null,'location',null,null,'Location:','Location',null,null,'T',null,'Location:','Location',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10201,null,'manufacturer',null,null,'Manufacturer:','Manufacturer',null,null,'T',null,'Manufacturer:','Manufacturer',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10201,null,'model_no',null,null,'Model #:','Model #',null,null,'T',null,'Model #:','Model #',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10201,null,'part_of',null,null,'Parent Asset:','Parent Asset',null,null,'T',null,'Parent Asset:','Parent Asset',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10201,null,'reason',null,null,'Reason:','Reason',null,null,'T',null,'Reason:','Reason',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10201,null,'serial_number',null,null,'Serial #:','Serial #',null,null,'T',null,'Serial #:','Serial #',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10201,null,'site',null,null,'Site:','Site',null,null,'T',null,'Site:','Site',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10201,null,'transact_as_whole',null,null,'Transact As Whole','Transact As Whole',null,null,'T',null,'Transact As Whole','Transact As Whole',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10201,null,'usrdefdate1',null,null,'Custom Date 1:','Enter a custom date.',null,null,'T',null,'Custom Date 1:','Enter a custom date.',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10201,null,'usrdefdate2',null,null,'Custom Date 2:','Enter a custom date.',null,null,'T',null,'Custom Date 2:','Enter a custom date.',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10201,null,'usrdefdate3',null,null,'Custom Date 3:','Enter a custom date.',null,null,'T',null,'Custom Date 3:','Enter a custom date.',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10201,null,'usrdefdate4',null,null,'Custom Date 4:','Enter a custom date.',null,null,'T',null,'Custom Date 4:','Enter a custom date.',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10201,null,'usrdefdate5',null,null,'Custom Date 5:','Enter a custom date.',null,null,'T',null,'Custom Date 5:','Enter a custom date.',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10201,null,'usrdefnumber1',null,null,'Custom No 1:','Enter a custom number.',null,null,'T',null,'Custom No 1:','Enter a custom number.',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10201,null,'usrdefnumber2',null,null,'Custom No 2:','Enter a custom number.',null,null,'T',null,'Custom No 2:','Enter a custom number.',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10201,null,'usrdefnumber3',null,null,'Custom No 3:','Enter a custom number.',null,null,'T',null,'Custom No 3:','Enter a custom number.',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10201,null,'usrdefnumber4',null,null,'Custom No 4:','Enter a custom number.',null,null,'T',null,'Custom No 4:','Enter a custom number.',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10201,null,'usrdefnumber5',null,null,'Custom No 5:','Enter a custom number.',null,null,'T',null,'Custom No 5:','Enter a custom number.',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10201,null,'usrdeftext1',null,null,'Custom Text 1:','Enter a custom text.',null,null,'T',null,'Custom Text 1:','Enter a custom text.',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10201,null,'usrdeftext10',null,null,'Custom Text10:','Enter a custom text.',null,null,'T',null,'Custom Text10:','Enter a custom text.',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10201,null,'usrdeftext2',null,null,'Custom Text 2:','Enter a custom text.',null,null,'T',null,'Custom Text 2:','Enter a custom text.',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10201,null,'usrdeftext3',null,null,'Custom Text 3:','Enter a custom text.',null,null,'T',null,'Custom Text 3:','Enter a custom text.',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10201,null,'usrdeftext4',null,null,'Custom Text 4:','Enter a custom text.',null,null,'T',null,'Custom Text 4:','Enter a custom text.',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10201,null,'usrdeftext5',null,null,'Custom Text 5:','Enter a custom text.',null,null,'T',null,'Custom Text 5:','Enter a custom text.',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10201,null,'usrdeftext6',null,null,'Custom Text 6:','Enter a custom text.',null,null,'T',null,'Custom Text 6:','Enter a custom text.',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10201,null,'usrdeftext7',null,null,'Custom Text 7:','Enter a custom text.',null,null,'T',null,'Custom Text 7:','Enter a custom text.',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10201,null,'usrdeftext8',null,null,'Custom Text 8:','Enter a custom text.',null,null,'T',null,'Custom Text 8:','Enter a custom text.',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10201,null,'usrdeftext9',null,null,'Custom Text 9:','Enter a custom text.',null,null,'T',null,'Custom Text 9:','Enter a custom text.',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10202,null,'asset_tag',null,null,'Asset Tag:','Asset Tag',null,null,'T',null,'Asset Tag:','Asset Tag',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10202,null,'category',null,null,'Category:','Category',null,null,'T',null,'Category:','Category',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10202,null,'class',null,null,'Depr.Class:','Class',null,null,'T',null,'Depr.Class:','Class',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10202,null,'contains',null,null,'Child Assets:','Child Assets',null,null,'T',null,'Child Assets:','Child Assets',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10202,null,'department',null,null,'Department:','Department',null,null,'T',null,'Department:','Department',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10202,null,'description',null,null,'Description:','Description',null,null,'T',null,'Description:','Description',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10202,null,'item_id',null,null,'Asset Type:','Asset Type',null,null,'T',null,'Asset Type:','Asset Type',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10202,null,'location',null,null,'Location:','Location',null,null,'T',null,'Location:','Location',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10202,null,'manufacturer',null,null,'Manufacturer:','Manufacturer',null,null,'T',null,'Manufacturer:','Manufacturer',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10202,null,'model_no',null,null,'Model #:','Model #',null,null,'T',null,'Model #:','Model #',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10202,null,'part_of',null,null,'Parent Asset:','Parent Asset',null,null,'T',null,'Parent Asset:','Parent Asset',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10202,null,'serial_number',null,null,'Serial #:','Serial #',null,null,'T',null,'Serial #:','Serial #',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10202,null,'site',null,null,'Site:','Site',null,null,'T',null,'Site:','Site',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10202,null,'transact_as_whole',null,null,'Transact As Whole','Transact As Whole',null,null,'T',null,'Transact As Whole','Transact As Whole',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10202,null,'usrdefdate1',null,null,'Custom Date 1:','Enter a custom date.',null,null,'T',null,'Custom Date 1:','Enter a custom date.',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10202,null,'usrdefdate2',null,null,'Custom Date 2:','Enter a custom date.',null,null,'T',null,'Custom Date 2:','Enter a custom date.',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10202,null,'usrdefdate3',null,null,'Custom Date 3:','Enter a custom date.',null,null,'T',null,'Custom Date 3:','Enter a custom date.',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10202,null,'usrdefdate4',null,null,'Custom Date 4:','Enter a custom date.',null,null,'T',null,'Custom Date 4:','Enter a custom date.',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10202,null,'usrdefdate5',null,null,'Custom Date 5:','Enter a custom date.',null,null,'T',null,'Custom Date 5:','Enter a custom date.',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10202,null,'usrdefnumber1',null,null,'Custom No 1:','Enter a custom number.',null,null,'T',null,'Custom No 1:','Enter a custom number.',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10202,null,'usrdefnumber2',null,null,'Custom No 2:','Enter a custom number.',null,null,'T',null,'Custom No 2:','Enter a custom number.',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10202,null,'usrdefnumber3',null,null,'Custom No 3:','Enter a custom number.',null,null,'T',null,'Custom No 3:','Enter a custom number.',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10202,null,'usrdefnumber4',null,null,'Custom No 4:','Enter a custom number.',null,null,'T',null,'Custom No 4:','Enter a custom number.',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10202,null,'usrdefnumber5',null,null,'Custom No 5:','Enter a custom number.',null,null,'T',null,'Custom No 5:','Enter a custom number.',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10202,null,'usrdeftext1',null,null,'Custom Text 1:','Enter a custom text.',null,null,'T',null,'Custom Text 1:','Enter a custom text.',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10202,null,'usrdeftext10',null,null,'Custom Text10:','Enter a custom text.',null,null,'T',null,'Custom Text10:','Enter a custom text.',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10202,null,'usrdeftext2',null,null,'Custom Text 2:','Enter a custom text.',null,null,'T',null,'Custom Text 2:','Enter a custom text.',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10202,null,'usrdeftext3',null,null,'Custom Text 3:','Enter a custom text.',null,null,'T',null,'Custom Text 3:','Enter a custom text.',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10202,null,'usrdeftext4',null,null,'Custom Text 4:','Enter a custom text.',null,null,'T',null,'Custom Text 4:','Enter a custom text.',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10202,null,'usrdeftext5',null,null,'Custom Text 5:','Enter a custom text.',null,null,'T',null,'Custom Text 5:','Enter a custom text.',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10202,null,'usrdeftext6',null,null,'Custom Text 6:','Enter a custom text.',null,null,'T',null,'Custom Text 6:','Enter a custom text.',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10202,null,'usrdeftext7',null,null,'Custom Text 7:','Enter a custom text.',null,null,'T',null,'Custom Text 7:','Enter a custom text.',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10202,null,'usrdeftext8',null,null,'Custom Text 8:','Enter a custom text.',null,null,'T',null,'Custom Text 8:','Enter a custom text.',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10202,null,'usrdeftext9',null,null,'Custom Text 9:','Enter a custom text.',null,null,'T',null,'Custom Text 9:','Enter a custom text.',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10203,null,'asset_tag',null,null,'Asset Tag:','Asset Tag',null,null,'T',null,'Asset Tag:','Asset Tag',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10203,null,'description',null,null,'Description:','Description',null,null,'T',null,'Description:','Description',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10203,null,'serial_number',null,null,'Serial #:','Serial #',null,null,'T',null,'Serial #:','Serial #',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10204,null,'asset_tag',null,null,'Asset Tag:','Asset Tag',null,null,'T',null,'Asset Tag:','Asset Tag',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10204,null,'description',null,null,'Description:','Description',null,null,'T',null,'Description:','Description',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10204,null,'location',null,null,'Location:','Location',null,null,'T',null,'Location:','Location',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10204,null,'site',null,null,'Site:','Site',null,null,'T',null,'Site:','Site',null,null,null,null,null,null,null,1,'T','1','1');
GO
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10205,null,'asset_tag',null,null,'Asset Tag:','Asset Tag',null,null,'T',null,'Asset Tag:','Asset Tag',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10205,null,'customer',null,null,'Customer #:','Customer #',null,null,'T',null,'Customer #:','Customer #',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10205,null,'customer_name',null,null,'Customer Name:','Customer Name',null,null,'T',null,'Customer Name:','Customer Name',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10205,null,'description',null,null,'Description:','Description',null,null,'T',null,'Description:','Description',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10205,null,'due_date',null,null,'Due Date:','Due Date',null,null,'T',null,'Due Date:','Due Date',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10205,null,'due_time',null,null,'Due Time:','Due Time',null,null,'T',null,'Due Time:','Due Time',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10205,null,'employee',null,null,'Employee #:','Employee #',null,null,'T',null,'Employee #:','Employee #',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10205,null,'first_name',null,null,'First Name:','First Name',null,null,'T',null,'First Name:','First Name',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10205,null,'last_name',null,null,'Last Name:','Last Name',null,null,'T',null,'Last Name:','Last Name',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10205,null,'location',null,null,'Location:','Location',null,null,'T',null,'Location:','Location',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10205,null,'site',null,null,'Site:','Site',null,null,'T',null,'Site:','Site',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10206,null,'asset_tag',null,null,'Asset Tag:','Asset Tag',null,null,'T',null,'Asset Tag:','Asset Tag',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10206,null,'description',null,null,'Description:','Description',null,null,'T',null,'Description:','Description',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10206,null,'location',null,null,'Location:','Location',null,null,'T',null,'Location:','Location',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10206,null,'site',null,null,'Site:','Site',null,null,'T',null,'Site:','Site',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10207,null,'asset_tag',null,null,'Asset Tag:','Asset Tag',null,null,'T',null,'Asset Tag:','Asset Tag',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10207,null,'description',null,null,'Description:','Description',null,null,'T',null,'Description:','Description',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10207,null,'FROM_loc',null,null,'FROM Location:','FROM Location',null,null,'T',null,'FROM Location:','FROM Location',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10207,null,'FROM_site',null,null,'FROM Site:','FROM Site',null,null,'T',null,'FROM Site:','FROM Site',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10207,null,'to_location',null,null,'To Location:','To Location',null,null,'T',null,'To Location:','To Location',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10207,null,'to_site',null,null,'To Site:','To Site',null,null,'T',null,'To Site:','To Site',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10208,null,'asset_tag',null,null,'Asset Tag:','Asset Tag',null,null,'T',null,'Asset Tag:','Asset Tag',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10208,null,'completed',null,null,'Completed:','Completed',null,null,'T',null,'Completed:','Completed',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10208,null,'completed_on',null,null,'Completed On:','Completed on',null,null,'T',null,'Completed on:','Completed on',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10208,null,'condition',null,null,'Condition:','Condition',null,null,'T',null,'Condition:','Condition',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10208,null,'description',null,null,'Description:','Description',null,null,'T',null,'Description:','Description',null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (10208,null,'notes',null,null,'Notes:','Note',null,null,'T',null,'Notes:','Note',null,null,null,null,null,null,null,1,'T','1','1');

-- form 90000
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','accepted_qty',null,'accepted_qty','Accepted Qty',null,null,null,'T',null,'Accepted Qty',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','adjust_date',null,'adjust_date','Adjust Date',null,null,null,'T',null,'Adjust Date',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','assigned_to',null,'assigned_to','Assigned To',null,null,null,'T',null,'Assigned To',null,null,null,null,null,null,null,null,null,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','audit_date',null,'audit_date','Audit Date',null,null,null,'T',null,'Audit Date',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','audited_qty',null,'audited_qty','Audited Qty',null,null,null,'T',null,'Audited Qty',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','back_order',null,'back_order','Back Order',null,null,null,'T',null,'Back Order',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','bill_to',null,'bill_to','BILL TO',null,null,null,'T',null,'BILL TO',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','checked-out',null,'checked-out','Checked-Out',null,null,null,'T',null,'Checked-Out',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','checkin_date',null,'checkin_date','Check-In Date',null,null,null,'T',null,'Check-In Date',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','checkout_date',null,'checkout_date','Check-Out Date',null,null,null,'T',null,'Check-Out Date',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','completed',null,'completed','Completed',null,null,null,'T',null,'Completed',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','current_qty',null,'current_qty','Current Qty',null,null,null,'T',null,'Current Qty',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','currentl_site_location',null,'current_site_location','Current Site Location',null,null,null,'T',null,'Current Site Location',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','customer',null,'customer','Customer',null,null,null,'T',null,'Customer',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','customer_message',null,'customer_message','Customer Message',null,null,null,'T',null,'Customer Message',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','customer_name',null,'customer_name','Customer Name',null,null,null,'T',null,'Customer Name',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','daily',null,'daily','Daily',null,null,null,'T',null,'Daily',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','date',null,'date','Date',null,'T','T','T',null,'Date',null,'T','T',null,62,null,1,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','date_acquired',null,'date_acquired','Date Acquired',null,null,null,'T',null,'Date Acquired',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','date_added',null,'date_added','Date Added',null,null,null,'T',null,'Date Added',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','date_audited',null,'date_audited','Date Audited',null,null,null,'T',null,'Date Audited',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','date_disposed',null,'date_disposed','Date Disposed',null,null,null,'T',null,'Date Disposed',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','date_moved',null,'date_moved','Date Moved',null,null,null,'T',null,'Date Moved',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','date_started',null,'date_started','Date Started',null,null,null,'T',null,'Date Started',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','department',null,'department','Department',null,null,null,'T',null,'Department',null,null,null,null,null,null,null,null,null,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','description',null,'description','Description',null,null,null,'T',null,'Description',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','discrepancy',null,'discrepancy','Discrepancy',null,null,null,'T',null,'Discrepancy',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','due_date',null,'due_date','Due Date',null,null,null,'T',null,'Due Date',null,null,null,null,null,null,null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','dvalue',null,'dvalue','Dvalue',null,null,null,'T',null,'Dvalue',null,null,null,null,null,null,null,null,1,'T','1','1');

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','employee_first_name',null,'employee_first_name','Employee First Name',null,null,null,'T',null,'Employee First Name',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','employee_last_name',null,'employee_last_name','Employee Last Name',null,null,null,'T',null,'Employee Last Name',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','employee_name',null,'employee_name','Employee Name','Enter employee number.  Employee number must be unique.','T','T','T',30,'Employee Name','Enter employee number.  Employee number must be unique.','T','T',30,null,null,null,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','error_description',null,'error_description','Error Description',null,null,null,'T',null,'Error Description',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','error_number',null,'error_number','Error Number',null,null,null,'T',null,'Error Number',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','error_type',null,'error_type','Error Type',null,null,null,'T',null,'Error Type',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','expected_date',null,'expected_date','Expected Date',null,null,null,'T',null,'Expected Date',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','extension',null,'extension','Extension',null,null,null,'T',null,'Extension',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','first_name',null,'first_name','First Name',null,null,null,'T',null,'First Name',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','FROM',null,'FROM','FROM',null,null,null,'T',null,'FROM',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','grand_total',null,'grand_total','Grand Total',null,null,null,'T',null,'Grand Total',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','id_reference',null,'id_reference','ID/Reference',null,null,null,'T',null,'ID/Reference',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','in_progress',null,'in_progress','In Progress',null,null,null,'T',null,'In Progress',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','internal_id',null,'internal_id','Internal ID',null,null,null,'T',null,'Internal ID',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','invoice_status',null,'invoice_status','Invoice Status',null,null,null,'T',null,'Invoice Status',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','item',null,'item','Asset Type',null,null,null,'T',null,'Asset Type',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','item_information',null,'item_information','Item Information',null,null,null,'T',null,'Item Information',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','last_audit_date',null,'last_audit_date','Last Audit Date',null,null,null,'T',null,'Last Audit Date',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','last_name',null,'last_name','Last Name',null,null,null,'T',null,'Last Name',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','line_item_count',null,'line_item_count','Line Item Count',null,null,null,'T',null,'Line Item Count',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','login_name',null,'login_name','Login Name',null,null,null,'T',null,'Login Name',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','maintenance',null,'maintenance','Maintenance',null,null,null,'T',null,'Maintenance',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','memo',null,'memo','Memo',null,null,null,'T',null,'Memo',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','monthly',null,'monthly','Monthly',null,null,null,'T',null,'Monthly',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','move_date',null,'move_date','Move Date',null,null,null,'T',null,'Move Date',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','never_audited',null,'never_audited','Never Audited',null,null,null,'T',null,'Never Audited',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','no',null,'no','No',null,null,null,'T',null,'No',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','no_of_assets',null,'no_of_assets','Number of Assets',null,null,null,'T',null,'Number of Assets',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','notes',null,'notes','Notes',null,null,null,'T',null,'Notes',null,null,null,null,null,null,null,null,1,'F','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','object_type',null,'object_type','Object Type',null,null,null,'T',null,'Object Type',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','occurs_every',null,'occurs_every','Occurs Every',null,null,null,'T',null,'Occurs Every',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','occurs_type',null,'occurs_type','Frequency',null,null,null,'T',null,'Frequency',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','order_quantity',null,'order_quantity','Original Order Qty',null,null,null,'T',null,'Original Order Qty',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','original_data',null,'original_data','Original Data',null,null,null,'T',null,'Original Data',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','original_qty',null,'original_qty','Original Qty',null,null,null,'T',null,'Original Qty',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','original_site_location',null,'original_site_location','Original Site Location',null,null,null,'T',null,'Original Site Location',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','originating',null,'originating','Originating',null,null,null,'T',null,'Originating',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','out_date',null,'out_date','Out Date',null,null,null,'T',null,'Out Date',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','parent',null,'parent','Parent',null,null,null,'T',null,'Parent',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','phone_number',null,'phone_number','Phone Number',null,null,null,'T',null,'Phone Number',null,null,null,null,null,null,null,null,null,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','pick_date',null,'pick_date','Pick Date',null,null,null,'T',null,'Pick Date',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','po_status',null,'po_status','PO Status',null,null,null,'T',null,'PO Status',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','process_type',null,'process_type','Process Type',null,null,null,'T',null,'Process Type',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','putaway_location',null,'putaway_location','Put-away Location',null,null,null,'T',null,'Put-away Location',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','putaway_site',null,'putaway_site','Put-away Site',null,null,null,'T',null,'Put-away Site',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','receive_date',null,'receive_date','Receive Date',null,null,null,'T',null,'Receive Date',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','received_quantity',null,'received_quantity','Received Qty',null,null,null,'T',null,'Received Qty',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','security_options',null,'security_options','Security Options',null,null,null,'T',null,'Security Options',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','ship_quantity',null,'ship_quantity','Ship Quantity',null,null,null,'T',null,'Ship Quantity',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','ship_to',null,'ship_to','SHIP TO',null,null,null,'T',null,'SHIP TO',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','specific_date',null,'specific_date','Specific Date',null,null,null,'T',null,'Specific Date',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','status',null,'status','Status',null,null,null,'T',null,'Status',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','to',null,'to','To',null,null,null,'T',null,'To',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','total',null,'total','Total',null,null,null,'T',null,'Total',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','transaction_date',null,'transaction_date','Transaction Date',null,null,null,'T',null,'Transaction Date',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','type',null,'type','Type',null,null,null,'T',null,'Type',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','user_first_name',null,'user_first_name','User First Name',null,null,null,'T',null,'User First Name',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','user_last_name',null,'user_last_name','User Last Name',null,null,null,'T',null,'User Last Name',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','user_logon_name',null,'user_logon_name','User Logon Name',null,null,null,'T',null,'User Logon Name',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','user_name',null,'user_name','User Name',null,null,null,'T',null,'User Name',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','vendor',null,'vendor','Vendor',null,null,null,'T',null,'Vendor',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','weekly',null,'weekly','Weekly',null,null,null,'T',null,'Weekly',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','yes',null,'yes','Yes',null,null,null,'T',null,'Yes',null,null,null,null,null,null,null,null,1,'T','1','1');

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','original_location',null,'original_location','Original Location',null,null,null,'T',null,'Original Location',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','audit_location',null,'audit_location','Audit Location',null,null,null,'T',null,'Audit Location',null,null,null,null,null,null,null,null,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','audited_to_location',null,'audited_to_location','Audited to Location',null,null,null,'T',null,'Audited to Location',null,null,null,null,null,null,null,null,1,'T','1','1');

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (90000,'CR','name',null,'name','Name',null,null,null,'T',null,'Name',null,null,null,null,null,null,null,null,1,'T','1','1');



-- form 20xx
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2000,'Label','BuildInfo',null,'BuildInfo','Build#:',null,null,null,'T',null,'Build#:',null,null,null,null,null,null,2,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2000,'Label','ButtonClear',null,'ButtonClear','Clear',null,null,null,'T',null,'Clear',null,null,null,null,null,null,7,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2000,'Label','ButtonOk',null,'ButtonOk','Ok',null,null,null,'T',null,'Ok',null,null,null,null,null,null,6,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2000,'Label','LabelLogInto',null,'LabelLogInto','Log into MobileAsset:',null,null,null,'T',null,'Log into MobileAsset:',null,null,null,null,null,null,3,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2000,'Label','LabelPassword',null,'LabelPassword','Password:',null,null,null,'T',null,'Password:',null,null,null,null,null,null,5,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2000,'Label','LabelUser',null,'LabelUser','User Name:',null,null,null,'T',null,'User Name:',null,null,null,null,null,null,4,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2000,'Label','MsgBadLogin',null,'MsgBadLogin','Invalid user name and password',null,null,null,'T',null,'Invalid user name and password',null,null,null,null,null,null,8,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2000,'Label','Title',null,'Title','MobileAsset',null,null,null,'T',null,'MobileAsset',null,null,null,null,null,null,1,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2001,'Label','ButtonAddNew',null,'ButtonAddNew','Add New',null,null,null,'T',null,'Add New',null,null,null,null,null,null,10,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2001,'Label','ButtonAuditAssets',null,'ButtonAuditAssets','Audit',null,null,null,'T',null,'Audit',null,null,null,null,null,null,15,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2001,'Label','ButtonCheckIn',null,'ButtonCheckIn','Check-In',null,null,null,'T',null,'Check-In',null,null,null,null,null,null,14,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2001,'Label','ButtonCheckOut',null,'ButtonCheckOut','Check-Out',null,null,null,'T',null,'Check-Out',null,null,null,null,null,null,13,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2001,'Label','ButtonDispose',null,'ButtonDispose','Dispose',null,null,null,'T',null,'Dispose',null,null,null,null,null,null,16,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2001,'Label','ButtonEdit',null,'ButtonEdit','Edit',null,null,null,'T',null,'Edit',null,null,null,null,null,null,11,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2001,'Label','ButtonMove',null,'ButtonMove','Move',null,null,null,'T',null,'Move',null,null,null,null,null,null,12,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2001,'Label','Title',null,'Title','MobileAsset',null,null,null,'T',null,'MobileAsset',null,null,null,null,null,null,9,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2002,'Label','ButtonClose',null,'ButtonClose','Close',null,null,null,'T',null,'Close',null,null,null,null,null,null,26,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2002,'Label','ButtonI',null,'ButtonI','i',null,null,null,'T',null,'i',null,null,null,null,null,null,27,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2002,'Label','ButtonOK',null,'ButtonOK','OK',null,null,null,'T',null,'OK',null,null,null,null,null,null,25,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2002,'Label','LabelDepartment',null,'LabelDepartment','Dept:',null,null,null,'T',null,'Dept:',null,null,null,null,null,null,24,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2002,'Label','LabelDesc',null,'LabelDesc','Description: ',null,null,null,'T',null,'Description: ',null,null,null,null,null,null,22,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2002,'Label','LabelItemId',null,'LabelItemId','Asset Type:',null,null,null,'T',null,'Asset Type:',null,null,null,null,null,null,21,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2002,'Label','LabelLocation',null,'LabelLocation','Location:',null,null,null,'T',null,'Location:',null,null,null,null,null,null,19,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2002,'Label','LabelSite',null,'LabelSite','Site:',null,null,null,'T',null,'Site:',null,null,null,null,null,null,18,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2002,'Label','LabelSN',null,'LabelSN','Serial #:',null,null,null,'T',null,'Serial #:',null,null,null,null,null,null,23,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2002,'Label','LabelTag',null,'LabelTag','Asset Tag:',null,null,null,'T',null,'Asset Tag:',null,null,null,null,null,null,20,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2002,'Label','MsgEnterItemId',null,'MsgEnterItemId','Enter Asset Type',null,null,null,'T',null,'Enter Asset Type',null,null,null,null,null,null,33,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2002,'Label','MsgEnterLoc',null,'MsgEnterLoc','Enter Location',null,null,null,'T',null,'Enter Location',null,null,null,null,null,null,31,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2002,'Label','MsgEnterSite',null,'MsgEnterSite','Enter Site',null,null,null,'T',null,'Enter Site',null,null,null,null,null,null,30,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2002,'Label','MsgEnterSN',null,'MsgEnterSN','Enter Serial Number',null,null,null,'T',null,'Enter Serial Number',null,null,null,null,null,null,34,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2002,'Label','MsgEnterTag',null,'MsgEnterTag','Enter Asset Tag',null,null,null,'T',null,'Enter Asset Tag',null,null,null,null,null,null,32,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2002,'Label','MsgNewLoc',null,'MsgNewLoc','Do you want to add this new location',null,null,null,'T',null,'Do you want to add this new location',null,null,null,null,null,null,29,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2002,'Label','MsgSiteNF',null,'MsgSiteNF','Site not found',null,null,null,'T',null,'Site not found',null,null,null,null,null,null,28,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2002,'Label','MsgTagEXISTS',null,'MsgTagEXISTS','Asset Tag already EXISTS',null,null,null,'T',null,'Asset Tag already EXISTS',null,null,null,null,null,null,35,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2002,'Label','Title',null,'Title','New Asset',null,null,null,'T',null,'New Asset',null,null,null,null,null,null,17,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2003,'Label','ButtonCancel',null,'ButtonCancel','Cancel',null,null,null,'T',null,'Cancel',null,null,null,null,null,null,45,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2003,'Label','ButtonOK',null,'ButtonOK','OK',null,null,null,'T',null,'OK',null,null,null,null,null,null,44,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2003,'Label','LabelClass',null,'LabelClass','Depr.Class:',null,null,null,'T',null,'Depr.Class:',null,null,null,null,null,null,39,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2003,'Label','LabelCOD',null,'LabelCOD','CO Duration:',null,null,null,'T',null,'CO Duration:',null,null,null,null,null,null,43,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2003,'Label','LabelCTG',null,'LabelCTG','Category:',null,null,null,'T',null,'Category:',null,null,null,null,null,null,40,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2003,'Label','LabelDesc',null,'LabelDesc','Description: ',null,null,null,'T',null,'Description: ',null,null,null,null,null,null,38,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2003,'Label','LabelItemId',null,'LabelItemId','Asset Type:',null,null,null,'T',null,'Asset Type:',null,null,null,null,null,null,37,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2003,'Label','LabelMfg',null,'LabelMfg','Mfg:',null,null,null,'T',null,'Mfg:',null,null,null,null,null,null,41,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2003,'Label','LabelModelInfo',null,'LabelModelInfo','Model#:',null,null,null,'T',null,'Model#:',null,null,null,null,null,null,42,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2003,'Label','PromptCategory',null,'PromptCategory','Enter Category',null,null,null,'T',null,'Enter Category',null,null,null,null,null,null,49,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2003,'Label','PromptClass',null,'PromptClass','Enter Class',null,null,null,'T',null,'Enter Class',null,null,null,null,null,null,48,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2003,'Label','PromptCOD',null,'PromptCOD','Enter CO Duration',null,null,null,'T',null,'Enter CO Duration',null,null,null,null,null,null,52,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2003,'Label','PromptDesc',null,'PromptDesc','Enter Description',null,null,null,'T',null,'Enter Description',null,null,null,null,null,null,47,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2003,'Label','PromptItemId',null,'PromptItemId','Enter Asset Type',null,null,null,'T',null,'Enter Asset Type',null,null,null,null,null,null,46,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2003,'Label','PromptMfg',null,'PromptMfg','Enter Mfg',null,null,null,'T',null,'Enter Mfg',null,null,null,null,null,null,50,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2003,'Label','PromptModelNo',null,'PromptModelNo','Enter Model #',null,null,null,'T',null,'Enter Model #',null,null,null,null,null,null,51,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2003,'Label','Title',null,'Title','New Asset Type',null,null,null,'T',null,'New Asset Type',null,null,null,null,null,null,36,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2004,'Label','ButtonCancel',null,'ButtonCancel','Cancel',null,null,null,'T',null,'Cancel',null,null,null,null,null,null,61,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2004,'Label','ButtonFind',null,'ButtonFind','Find',null,null,null,'T',null,'Find',null,null,null,null,null,null,59,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2004,'Label','ButtonNew',null,'ButtonNew','New',null,null,null,'T',null,'New',null,null,null,null,null,null,62,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2004,'Label','ButtonOK',null,'ButtonOK','OK',null,null,null,'T',null,'OK',null,null,null,null,null,null,60,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2004,'Label','TitleAssets',null,'TitleAssets','Search Assets',null,null,null,'T',null,'Search Assets',null,null,null,null,null,null,53,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2004,'Label','TitleCustomers',null,'TitleCustomers','Search Customers',null,null,null,'T',null,'Search Customers',null,null,null,null,null,null,54,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2004,'Label','TitleEmployees',null,'TitleEmployees','Search Employees',null,null,null,'T',null,'Search Employees',null,null,null,null,null,null,55,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2004,'Label','TitleItems',null,'TitleItems','Search Asset Type',null,null,null,'T',null,'Search Asset Type',null,null,null,null,null,null,56,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2004,'Label','TitleLocations',null,'TitleLocations','Search Locations',null,null,null,'T',null,'Search Locations',null,null,null,null,null,null,57,1,1,'T','1','1');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (2004,'Label','TitleSites',null,'TitleSites','Search Sites',null,null,null,'T',null,'Search Sites',null,null,null,null,null,null,58,1,1,'T','1','1');




----------------------------------------------------
-- Table Name: label_names
----------------------------------------------------
DELETE FROM label_names

INSERT INTO label_names (lbl_id,lbl_type,lbl_display_order,lbl_name,lbl_file_name,lbl_default_name,lbl_tool_tips,lbl_image_name) values (201,1001,2,'Location Labels','Location Labels','Location Labels',null,'Labels_Location');
INSERT INTO label_names (lbl_id,lbl_type,lbl_display_order,lbl_name,lbl_file_name,lbl_default_name,lbl_tool_tips,lbl_image_name) values (101,-2000,1,'Asset Tag New','Asset Tag NewDB','Asset Tag New',null,'Label');
INSERT INTO label_names (lbl_id,lbl_type,lbl_display_order,lbl_name,lbl_file_name,lbl_default_name,lbl_tool_tips,lbl_image_name) values (301,1001,3,'Employee Badges','Employee Badges','Employee Badges',null,'Labels_Employee');
INSERT INTO label_names (lbl_id,lbl_type,lbl_display_order,lbl_name,lbl_file_name,lbl_default_name,lbl_tool_tips,lbl_image_name) values (1001,1001,4,'Launch Labeler','Launch Labeler','Launch Labeler',null,'Launch_Labeler');
INSERT INTO label_names (lbl_id,lbl_type,lbl_display_order,lbl_name,lbl_file_name,lbl_default_name,lbl_tool_tips,lbl_image_name) values (1002,1001,5,'Browse to Label File','Browse to Label File','Browse to Label File',null,'Labels_Browse');
INSERT INTO label_names (lbl_id,lbl_type,lbl_display_order,lbl_name,lbl_file_name,lbl_default_name,lbl_tool_tips,lbl_image_name) values (203,1001,1,'Asset Tags','Asset Tags','Asset Tags',null,'Labels_Asset_Tags');
GO


----------------------------------------------------
-- Table Name: notes
-- Due to a previous application bug: imported assets may not have a corresponding notes
-- record in the notes table 
----------------------------------------------------
INSERT INTO [notes]
SELECT asset_id, 'asset', '', GetDate(), 1, 1, 1 FROM asset WHERE asset_id NOT IN (SELECT note_id FROM notes WHERE table_name = 'asset') and record_status = 1 and company_id = 1
GO



----------------------------------------------------
-- Table Name: report_label_types
----------------------------------------------------
DELETE FROM report_label_types

INSERT INTO report_label_types (type_id,type_display_order,type_name,type_default_name) values (1,10,'Asset Type Reports','Asset Type Reports');
INSERT INTO report_label_types (type_id,type_display_order,type_name,type_default_name) values (14,2,'Asset Depreciation Reports','Asset Depreciation Reports');
INSERT INTO report_label_types (type_id,type_display_order,type_name,type_default_name) values (3,11,'Location Reports','Location Reports');
INSERT INTO report_label_types (type_id,type_display_order,type_name,type_default_name) values (4,8,'Customer Reports','Customer Reports');
INSERT INTO report_label_types (type_id,type_display_order,type_name,type_default_name) values (5,5,'Check-Out to Customer Reports','Check-Out to Customer Reports');
INSERT INTO report_label_types (type_id,type_display_order,type_name,type_default_name) values (6,12,'Transaction Reports','Transaction Reports');
INSERT INTO report_label_types (type_id,type_display_order,type_name,type_default_name) values (15,3,'Asset Maintenance Reports','Asset Maintenance Reports');
INSERT INTO report_label_types (type_id,type_display_order,type_name,type_default_name) values (16,6,'Check-Out to Employee Reports','Check-Out to Employee Reports');
INSERT INTO report_label_types (type_id,type_display_order,type_name,type_default_name) values (10,13,'Other Reports','Other Reports');
INSERT INTO report_label_types (type_id,type_display_order,type_name,type_default_name) values (11,4,'Audit Reports','Audit Reports');
INSERT INTO report_label_types (type_id,type_display_order,type_name,type_default_name) values (1001,1,'Labels','Labels');
INSERT INTO report_label_types (type_id,type_display_order,type_name,type_default_name) values (12,1,'Asset Reports','Asset Reports');
INSERT INTO report_label_types (type_id,type_display_order,type_name,type_default_name) values (13,9,'Employee Reports','Employee Reports');
INSERT INTO report_label_types (type_id,type_display_order,type_name,type_default_name) values (17,7,'Contract/License Reports','Contract/License Reports');


----------------------------------------------------
-- Table Name: report_labels
----------------------------------------------------
DELETE FROM report_labels

INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (611,'site_name',null,'MoveFROM',8,'site_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1002,'fax',null,'Manufacturer',5,null,'fax');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (802,'quantity',null,'Item',90000,'original_order_qty',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (703,'due_date',null,'Invoice Pick',22,'due_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1108,'location_description',null,'Location',7,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (802,'site_name1',null,'Item Receive',8,'site_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (708,'ref_number',null,'Invoice Pick',0,null,null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (613,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (402,'phone_number',null,'Supplier',4,null,'phone_number');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (402,'address1',null,'Supplier',9,'address1',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1003,'extension',null,'Supplier',9,null,'extension');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (613,'last_name',null,'User',90000,'last_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1003,'address1',null,'Supplier',9,'address1',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1503,'last_name',null,'User',90000,'last_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (708,'allow_shorting',null,'vInvoiceInfo',4,'allow_shorting',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (703,'picked_quantity',null,'Item',90000,'ship_quantity',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1107,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (803,'ref_number',null,'Item Receive',1000,'po',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1108,'quantity',null,'Inventory',11,'quantity',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1502,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1003,'website',null,'Supplier',9,'website',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1001,'city',null,'Supplier',9,'city',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (604,'customer_number',null,'Customer',4,'customer_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (501,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (705,'ref_number',null,'Invoice Pick',1001,'po',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1107,'trans_date',null,'Inventory',13,'trans_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1003,'postal_code',null,'Supplier',9,'postal_code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1002,'address1',null,'Manufacturer',5,'address1',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1001,'ccell',null,'Supplier',9,null,'Contact Cell Phone');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (609,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1107,'lot',null,'Inventory',11,'lot',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (508,'trans_date',null,'Inventory',90000,'out_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (510,'employee_first_name',null,'Employee',30,'first_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (510,'employee_extension',null,'Employee',4,'extension',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (605,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (605,'customer_phone_number',null,'Customer',90000,'phone_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (611,'description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1001,'name',null,'Supplier',9,'name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (605,'customer_number',null,'Customer',4,'customer_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (201,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (401,'address2',null,'Supplier',9,'address2',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1501,'condition',null,'vAssetMaintenance',27,'condition',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1502,'serial_number',null,'Inventory',11,'serial_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1301,'phone_number',null,'Supplier',90000,'phone_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (401,'ccell',null,'Supplier',4,null,'Cell Phone');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (401,'city',null,'Supplier',9,'city',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (403,'name',null,'Supplier',9,'name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1303,'phone_number',null,'Supplier',90000,'phone_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1303,'employee_number',null,'vCheckOutInfo',30,'employee_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1303,'manager_last_name',null,'Manager',30,'last_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (403,'phone_number',null,'Supplier',4,null,'phone_number');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (403,'ccell',null,'Supplier',4,null,'cell phone');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (404,'email',null,'Supplier',9,'email',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (613,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (613,'po',null,'Inventory',11,'po',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (604,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (604,'trans_date',null,'Inventory',90000,'checkout_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (608,'trans_date',null,'Inventory',90000,'checkout_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (607,'user_last_name',null,'User',90000,'user_last_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (105,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (105,'description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (702,'location',null,'Location',7,'code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (806,'description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (806,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (806,'quantity',null,'Inventory',11,'quantity',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (806,'quantity_received',null,'Item Receive',90000,'received_quantity',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (806,'po_type',null,'vPOinfo',22,'po_type',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (806,'ref_number',null,'Item Receive',1000,'po',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (104,'manufacturer',null,'vItemSummary',27,'manufacturer',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (0,'note_text',null,'SpSumNotes4Items;1',4,'note_text',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (0,'description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (105,'cost',null,'Item',6,'cost',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (105,'catagory',null,'vItemSummary',27,'category',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (105,'alt_item_number',null,'item',6,'alt_item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (106,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (106,'cost',null,'Item',6,'cost',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (106,'manufacturer',null,'vItemSummary',27,'manufacturer',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (106,'alt_item_number',null,'item',6,'alt_item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (0,'cost',null,'Item',6,'cost',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (0,'supplier',null,'vItemSummary',6,'supplier',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (0,'alt_item_number',null,'item',6,'alt_item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (504,'date_acquired',null,'Inventory',90000,'due_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (107,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (107,'description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (107,'cost',null,'Item',6,'cost',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (107,'alt_item_number',null,'item',6,'alt_item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (504,'employee_email',null,'Employee',2,'email',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (504,'purchase_cost',null,'vAssetInfo',27,'purchase_cost',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (502,'date_acquired',null,'Inventory',90000,'due_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (505,'trans_date',null,'Inventory',90000,'out_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (503,'customer_number',null,'Customer',4,'customer_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (503,'customer_phone_number',null,'Customer',2,'phone_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (503,'customer_extension',null,'Customer',4,'extension',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (608,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (702,'quantity',null,'Item',90000,'order_quantity',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (10012,'ref_number',null,'Item Receipt',1000,'po',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (608,'employee_number',null,'vCheckOutInfo',30,'employee_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1003,'cphone',null,'Supplier',9,null,'Contact work phone');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1205,'item_number',null,'Item',6,'item_number',null);
GO
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1401,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1108,'current_qty',null,'Inventory',13,'current_qty',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (609,'last_name',null,'User',90000,'user_last_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (704,'ref_number',null,'Invoice Pick',1001,'po',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (704,'quantity',null,'Inventory',11,'quantity',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1107,'serial_number',null,'Inventory',11,'serial_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1107,'pallet',null,'Inventory',11,'pallet',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1701,'begin_date',null,'Contract',32,'begin_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1003,'email',null,'Supplier',9,'email',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1003,'country',null,'Supplier',9,'country',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (605,'trans_date',null,'Inventory',90000,'checkin_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1206,'purchase_cost',null,'vAssetInfo',27,'purchase_cost',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (801,'description',null,'Location',7,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1107,'site_description',null,'Site',8,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1105,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1701,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (605,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (506,'date_acquired',null,'Inventory',90000,'due_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1001,'cextension',null,'Supplier',9,null,'Contact work phone extension');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (609,'first_name',null,'User',90000,'user_first_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (506,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1108,'site_description',null,'Site',8,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (702,'qty',null,'Inventory',90000,'ship_quantity',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1002,'contact_name',null,'Manufacturer',5,'contact_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1002,'ccell',null,'Manufacturer',5,null,'Contact Cell Phone');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1004,'user_logon',null,'User',90000,'user_logon_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (10008,'original_data',null,'import_QB_errors',90000,'id_reference',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1003,'website',null,'Supplier',9,'website',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (802,'location1',null,'Location',7,'code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (708,'name',null,'Customer',4,'name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (707,'due_date',null,'Invoice Pick',22,'due_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (703,'quantity',null,'Order',90000,'order_quantity',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1210,'warranty_end_date',null,'asset',27,'warranty_end_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (104,'description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (104,'class_name',null,'vItemSummary',6,'class_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1201,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1401,'depreciated_value',null,'vAssetDepreciation',27,'depreciated_value',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1504,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1503,'serial_number',null,'Inventory',11,'serial_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1503,'code',null,'Location',7,'code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (501,'customer_extension',null,'Customer',4,'extension',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (501,'purchase_cost',null,'vAssetInfo',27,'purchase_cost',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (502,'customer_extension',null,'Customer',4,'extension',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (505,'customer_phone_number',null,'Customer',2,'phone_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (506,'customer_name',null,'Customer',4,'name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (509,'employee_phone_number',null,'Employee',2,'phone_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (510,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (510,'date_acquired',null,'Inventory',90000,'due_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (402,'state',null,'Supplier',9,'state',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (401,'fax',null,'Supplier',4,' ','Fax');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (401,'email',null,'Supplier',9,'email',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (403,'postal_code',null,'Supplier',9,'postal_code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (404,'phone_number',null,'Supplier',4,null,'phone_number');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (404,'state',null,'Supplier',9,'state',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (613,'serial_number',null,'Inventory',11,'serial_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (605,'customer_name',null,'Customer',90000,'customer_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (613,'trans_date',null,'Inventory',90000,'date_added',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (607,'employee_last_name',null,'Employee',90000,'employee_last_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (607,'employee_phone_number',null,'Employee',90000,'phone_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (609,'serial_number',null,'Inventory',11,'serial_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1002,'email',null,'Manufacturer',5,'email',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1002,'website',null,'Manufacturer',5,'website',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (402,'customer_number',null,'Customer',4,'customer_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (402,'date_added',null,'Customer',4,'date_added',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (401,'date_added',null,'Customer',4,'date_added',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (404,'extension',null,'Supplier',4,null,'extension');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (301,'site_description',null,'Site',8,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (301,'site_description',null,'Site',8,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (301,'code',null,'Location',7,'code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (205,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (205,'trans_date',null,'Inventory',13,'trans_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (205,'lot',null,'Inventory',11,'lot',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (204,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (204,'pallet',null,'Inventory',11,'pallet',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (204,'date_code',null,'Inventory',11,'date_code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (204,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (204,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (204,'lot',null,'Inventory',11,'lot',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (204,'pallet',null,'Inventory',11,'pallet',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (204,'date_code',null,'Inventory',11,'date_code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (203,'location_description',null,'Location',7,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (203,'site_name',null,'Site',8,'site_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (804,'description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (607,'trans_date',null,'Inventory',90000,'checkin_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (608,'employee_first_name',null,'Employee',90000,'employee_first_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (701,'due_date',null,'Invoice Pick',22,'due_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1101,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1108,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (705,'due_date',null,'Invoice Pick',22,'due_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1002,'cextension',null,'Manufacturer',5,null,'Contact work phone extension');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (505,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1108,'date_code',null,'Inventory',11,'date_code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1107,'quantity',null,'Inventory',11,'quantity',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (501,'customer_name',null,'Customer',4,'name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1210,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1105,'code',null,'Location',7,'code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (607,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (611,'first_name',null,'User',90000,'user_first_name',null);
GO
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (801,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (707,'customer_name',null,'Customer',4,'name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (702,'due_date',null,'Invoice Pick',22,'due_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (604,'user_first_name',null,'User',90000,'user_first_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (611,'entry_date',null,'Entry',90000,'move_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1001,'state',null,'Supplier',9,'state',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (704,'due_date',null,'Invoice Pick',22,'due_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (608,'employee_last_name',null,'Employee',90000,'employee_last_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (609,'trans_date',null,'Inventory',90000,'date_disposed',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (611,'moveto_site_name',null,'MoveTo',6,'site_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1001,'cfax',null,'Supplier',9,null,'Contact Fax');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1002,'cphone',null,'Manufacturer',5,null,'Contact work phone');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1001,'address2',null,'Supplier',9,'address2',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (505,'customer_name',null,'Customer',4,'name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (509,'date_acquired',null,'Inventory',90000,'due_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (509,'employee_first_name',null,'Employee',30,'first_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (510,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (10008,'error_description',null,'import_QB_errors',90000,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1001,'extension',null,'Supplier',9,null,'extension');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (205,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (204,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (204,'lot',null,'Inventory',11,'lot',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (204,'remaining_quantity',null,'Item',6,'qty_available',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (204,'site_name',null,'Site',8,'site_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (203,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (203,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (203,'code',null,'Location',7,'code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (203,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (203,'location_description',null,'Location',7,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (203,'code',null,'Location',7,'code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (203,'remaining_qty',null,'Inventory',13,'remaining_qty',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (202,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (202,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (202,'description',null,'Location',7,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (202,'quantity',null,'Inventory',11,'quantity',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (202,'site_description',null,'Site',8,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (202,'code',null,'Location',7,'code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (202,'site_name',null,'Site',8,'site_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (202,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (202,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (202,'quantity',null,'Inventory',11,'quantity',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (202,'site_description',null,'Site',8,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (202,'code',null,'Location',7,'code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (202,'site_name',null,'Site',8,'site_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (201,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (201,'location_description',null,'Location',7,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (201,'code',null,'Location',7,'code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (201,'site_description',null,'Site',8,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (201,'quantity',null,'Item',6,'qty_available',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (201,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (201,'site_description',null,'Site',8,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (201,'quantity',null,'Item',6,'qty_available',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (201,'CheckedoutQty',null,'Item',6,'qty_checked_out',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (201,'site_name',null,'Site',8,'site_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (605,'customer_extension',null,'Customer',90000,'extension',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (506,'customer_phone_number',null,'Customer',2,'phone_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (508,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (508,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (509,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (402,'email',null,'Supplier',9,'email',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (402,'extension',null,'Supplier',90000,'extension',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (0,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (107,'supplier',null,'vItemSummary',6,'supplier',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (401,'customer_number',null,'Customer',4,'customer_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (401,'name',null,'Supplier',9,'name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (106,'description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1001,'supplier_number',null,'Supplier',9,'supplier_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1001,'website',null,'Supplier',9,'website',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1002,'address2',null,'Manufacturer',5,'address2',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1101,'last_audit_date',null,'vAssetAudit',90000,'last_audit_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1401,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1203,'purchase_cost',null,'vAssetInfo',27,'purchase_cost',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1203,'category',null,'vAssetInfo',6,'category',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1205,'purchase_date',null,'vAssetInfo',27,'purchase_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1205,'location',null,'Location',7,'code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (607,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1205,'is_checked_out',null,'vAssetInfo',27,'is_checked_out',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (10007,'process_id',null,'import_QB_errors',90000,'error_type',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1208,'purchase_date',null,'vAssetInfo',27,'purchase_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (605,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (701,'website',null,'Manufacturer',5,'website',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (701,'description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (611,'code',null,'MoveFROM',7,'code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (504,'employee_number',null,'vCheckOutInfo',30,'employee_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1003,'mail_stop',null,'Supplier',9,'mail_stop',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1205,'serial_number',null,'Inventory',11,'serial_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (502,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1003,'contact_name',null,'Supplier',9,'contact_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1108,'trans_date',null,'Inventory',13,'trans_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (503,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1108,'lot',null,'Inventory',11,'lot',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1102,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (801,'ref_number',null,'Item Receive',1000,'po',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (702,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (604,'customer_email',null,'Customer',2,'email',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1002,'country',null,'Manufacturer',5,'country',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (708,'quantity',null,'Item',6,'qty_available',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (10008,'error_number',null,'import_QB_errors',90000,'object_type',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (704,'description',null,'Item',6,'description',null);
GO
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (702,'code',null,'Location',7,'code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1702,'contract_description',null,'Contract',32,'contract_description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1702,'internal_contact',null,'vContractInfo',32,'internal_contact',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (703,'ref_number',null,'Invoice Pick',1001,'po',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (701,'code',null,'Location',7,'code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1101,'description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1003,'address2',null,'Supplier',9,'address2',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (804,'quantity',null,'Inventory',11,'quantity',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1105,'date_code',null,'Inventory',11,'date_code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1001,'contact_name',null,'Supplier',9,'contact_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (702,'ref_number',null,'Invoice Pick',1001,'po',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (610,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (610,'code',null,'MoveFROM',7,'code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (505,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (504,'employee_extension',null,'Employee',4,'extension',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (507,'date_acquired',null,'Inventory',90000,'due_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1105,'lot',null,'Inventory',11,'lot',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1102,'serial_number',null,'Inventory',11,'serial_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1001,'postal_code',null,'Supplier',9,'postal_code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1001,'mail_stop',null,'Supplier',9,'mail_stop',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1107,'location_description',null,'Location',7,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1101,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1003,'fax',null,'Supplier',9,null,'fax');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (701,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1108,'pallet',null,'Inventory',11,'pallet',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (708,'code',null,'Location',7,'code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (703,'name',null,'Customer',4,'name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (708,'due_date',null,'Invoice Pick',22,'due_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1201,'purchase_date',null,'vAssetInfo',27,'purchase_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1502,'occurs_type',null,'vAssetMaintenance',90000,'occurs_type',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1504,'condition',null,'vAssetMaintenance',27,'condition',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1102,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1503,'site_name',null,'Site',8,'site_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1503,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1503,'condition',null,'vAssetMaintenance',27,'condition',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (510,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (510,'employee_email',null,'Employee',2,'email',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (402,'hphone',null,'Customer',4,' ','Home Phone');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (401,'extension',null,'Supplier',90000,'extension',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (403,'extension',null,'Supplier',4,null,'extension');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (403,'fax',null,'Supplier',4,null,'Fax');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (607,'employee_email',null,'Employee',2,'email',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (608,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (610,'moveto_site_name',null,'MoveTo',6,'site_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (604,'customer_phone_number',null,'Customer',90000,'phone_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (608,'employee_extension',null,'Employee',90000,'extension',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (608,'user_first_name',null,'User',90000,'user_first_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (610,'entry_date',null,'Entry',90000,'transaction_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1001,'cphone',null,'Supplier',9,null,'Contact work phone');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1004,'manager',null,'vUserSecurityInfo',6,'manager',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (402,'country',null,'Supplier',9,'country',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (401,'hphone',null,'Customer',4,' ','Home Phone');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (401,'state',null,'Supplier',9,'state',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (401,'postal_code',null,'Supplier',9,'postal_code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (403,'email',null,'Supplier',9,'email',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (404,'name',null,'Supplier',9,'name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (605,'customer_email',null,'Customer',2,'email',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (301,'location_description',null,'Location',7,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (301,'code',null,'Location',7,'code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (205,'quantity',null,'Inventory',11,'quantity',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (205,'date_code',null,'Inventory',11,'date_code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (205,'pallet',null,'Inventory',11,'pallet',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (205,'code',null,'Location',7,'code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (205,'last_name',null,'User',90000,'last_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (205,'adjust_type',null,'Inventory',13,'adjust_type',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (204,'code',null,'Location',7,'code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (204,'site_name',null,'Site',8,'site_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (204,'serial_number',null,'Inventory',11,'serial_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1502,'assigned_to',null,'vAssetMaintenance',90000,'assigned_to',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1504,'maint_complete',null,'Maint',90000,'status',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1002,'postal_code',null,'Manufacturer',5,'postal_code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (501,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1203,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (704,'site_name',null,'Site',8,'site_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1107,'code',null,'Location',7,'code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1104,'last_audit_date',null,'vAssetAudit',90000,'last_audit_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1105,'pallet',null,'Inventory',11,'pallet',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1203,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1107,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (613,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1107,'code',null,'Location',7,'code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (611,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1001,'email',null,'Supplier',9,'email',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (701,'Bill_address1',null,'Bill',2,'address1',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1001,'country',null,'Supplier',9,'country',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1108,'serial_number',null,'Inventory',11,'serial_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1702,'contract_number',null,'vContractInfo',32,'contract_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1702,'begin_date',null,'vContractInfo',32,'begin_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (708,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (703,'site_name',null,'Site',8,'site_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1702,'end_date',null,'vContractInfo',32,'end_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1003,'city',null,'Supplier',9,'city',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (704,'code',null,'Location',7,'code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1105,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1003,'address2',null,'Supplier',9,'address2',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (607,'employee_number',null,'vCheckOutInfo',30,'employee_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (607,'employee_first_name',null,'Employee',90000,'employee_first_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (608,'employee_phone_number',null,'Employee',90000,'phone_number',null);
GO
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (610,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (508,'employee_extension',null,'Employee',4,'extension',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (504,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (507,'employee_last_name',null,'Employee',30,'last_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1003,'state',null,'Supplier',9,'state',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1003,'ccell',null,'Supplier',9,null,'Contact Cell Phone');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (702,'site_name',null,'Site',8,'site_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1504,'code',null,'Location',7,'code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1504,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (505,'date_acquired',null,'Inventory',90000,'due_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (506,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (505,'customer_email',null,'Customer',2,'email',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (505,'customer_extension',null,'Customer',4,'extension',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (507,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (507,'employee_extension',null,'Employee',4,'extension',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (509,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (509,'employee_email',null,'Employee',2,'email',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (510,'trans_date',null,'Inventory',90000,'transout',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (510,'employee_number',null,'vCheckOutInfo',30,'employee_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (402,'fax',null,'Supplier',4,' ','Fax');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (402,'address2',null,'Supplier',9,'address2',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (404,'fax',null,'Supplier',4,null,'fax');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (404,'ccell',null,'Supplier',4,null,'cell phone');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1004,'title',null,'vUserSecurityInfo',30,'title',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (613,'first_name',null,'User',90000,'first_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1002,'cfax',null,'Manufacturer',5,null,'Contact Fax');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1002,'state',null,'Manufacturer',5,'state',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (401,'country',null,'Supplier',9,'country',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (301,'site_name',null,'Site',8,'site_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (301,'site_name',null,'Site',8,'site_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (301,'location_description',null,'Location',7,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (205,'first_name',null,'User',90000,'first_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (205,'site_name',null,'Site',8,'site_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (205,'adjust_code',null,'Adjust Reason',13,'adjust_code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (204,'serial_number',null,'Inventory',11,'serial_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (204,'remaining_quantity',null,'Item',6,'qty_available',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (204,'code',null,'Location',7,'code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (203,'serial_number',null,'Inventory',11,'serial_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (203,'site_description',null,'Site',8,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (203,'remaining_qty',null,'Inventory',13,'remaining_qty',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (203,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (203,'serial_number',null,'Inventory',11,'serial_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (203,'site_description',null,'Site',8,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (203,'site_name',null,'Site',8,'site_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (202,'description',null,'Location',7,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (201,'CheckedoutQty',null,'Item',6,'qty_checked_out',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (201,'site_name',null,'Site',8,'site_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (201,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (201,'location_description',null,'Location',7,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (201,'code',null,'Location',7,'code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (505,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (504,'trans_date',null,'Inventory',90000,'out_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (507,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1203,'serial_number',null,'Inventory',11,'serial_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1206,'purchase_date',null,'vAssetInfo',27,'purchase_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1206,'manufacturer_name',null,'Manufacturer',4,'name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1207,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1210,'warranty_begin_date',null,'asset',27,'warranty_begin_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1210,'description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1501,'schedule_date',null,'vAssetMaintenance',27,'schedule_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (505,'customer_number',null,'Customer',4,'customer_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1108,'site_description',null,'Site',8,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1102,'first_name',null,'User',90000,'first_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (706,'due_date',null,'Invoice Pick',22,'due_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1105,'serial_number',null,'Inventory',11,'serial_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1104,'location0',null,'Original',7,'code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1303,'extension',null,'Supplier',90000,'extension',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1303,'manager_first_name',null,'Manager',30,'first_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (803,'quantity_received',null,'PO Receive',90000,'received_quantity',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (802,'quantity_received1','Received Quantity','PO Receive',0,null,null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (802,'quantity_received2',null,'Item Receive',90000,'received_quantity',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (802,'due_date1',null,'Item Receive',22,'due_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1003,'phone_number',null,'Supplier',9,null,null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1210,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1105,'site_name',null,'Site',8,'site_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (501,'trans_date',null,'Inventory',90000,'out_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1501,'description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1003,'supplier_number',null,'Supplier',9,'supplier_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1003,'cextension','Cextension','Supplier',9,null,'Contact work phone extension');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1003,'email',null,'Supplier',9,'email',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1502,'condition',null,'vAssetMaintenance',27,'condition',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1401,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (708,'customer_number',null,'Customer',4,'customer_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (701,'customer_number',null,'Customer',4,'customer_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1108,'serial_number',null,'Inventory',11,'serial_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1107,'current_qty',null,'Inventory',13,'current_qty',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1004,'first_name',null,'User',90000,'user_first_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1102,'site_name',null,'Site',8,'site_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (604,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (610,'site_name',null,'MoveFROM',8,'site_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1002,'extension',null,'Manufacturer',5,null,'extension');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (701,'site_name',null,'Site',8,'site_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1501,'occurs_type',null,'vAssetMaintenance',90000,'occurs_type',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (802,'ref_number',null,'PO Receive',1000,'po',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1105,'site_description',null,'Site',8,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1701,'contract_number',null,'Contract',32,'contract_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1205,'purchase_cost',null,'vAssetInfo',27,'purchase_cost',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1206,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
GO
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1208,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1108,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1701,'contract_description',null,'Contract',32,'contract_description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (501,'customer_phone_number',null,'Customer',2,'phone_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1502,'description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1003,'mail_stop',null,'Supplier',9,'mail_stop',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1302,'phone_number',null,'Supplier',90000,'phone_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (611,'moveto_location',null,'MoveTo',17,'location',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (501,'date_acquired',null,'Inventory',90000,'due_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (504,'employee_first_name',null,'Employee',30,'first_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1201,'po',null,'Inventory',11,'po',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1204,'serial_number',null,'Inventory',11,'serial_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1204,'purchase_date',null,'vAssetInfo',27,'purchase_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1207,'po',null,'Inventory',11,'po',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (802,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (703,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (10012,'description',null,'Location',7,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1108,'quantity',null,'Inventory',11,'quantity',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (502,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1003,'cfax','Cfax','Supplier',9,null,'Contact Fax');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1003,'supplier_number',null,'Supplier',9,'supplier_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1001,'fax',null,'Supplier',9,null,'fax');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (702,'description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (604,'customer_name',null,'Customer',90000,'customer_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1301,'last_name',null,'User',90000,'last_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1301,'email',null,'Supplier',9,'email',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1302,'employee_number',null,'vCheckOutInfo',30,'employee_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (701,'code',null,'Location',7,'code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (604,'customer_extension',null,'Customer',90000,'extension',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1002,'city',null,'Manufacturer',5,'city',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (506,'trans_date',null,'Inventory',90000,'out_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (804,'ref_number',null,'Item Receive',15,'require_pos',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (10008,'process_id',null,'import_QB_errors',90000,'error_type',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (803,'quantity',null,'Item',6,'qty_available',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (10012,'po_type',null,'vPOinfo',22,'po_type',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (701,'quantity',null,'Item',6,'qty_available',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (613,'purchase_cost',null,'vAssetInfo',27,'purchase_cost',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1107,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1107,'site_name',null,'Site',8,'site_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1201,'serial_number',null,'Inventory',11,'serial_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (708,'site_name',null,'Site',8,'site_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (703,'ref_number','Invoice #','Invoice Pick',0,null,null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (507,'employee_phone_number',null,'Employee',2,'phone_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (611,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (611,'last_name',null,'User',90000,'user_last_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (503,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (613,'code',null,'Location',7,'code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1104,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (804,'quantity_received',null,'Item Receive',90000,'received_quantity',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1105,'site_description',null,'Site',8,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1104,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1102,'last_name',null,'User',90000,'last_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1003,'fax','Fax','Supplier',9,null,'fax');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1003,'name',null,'Supplier',9,'name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1208,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1108,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1105,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1105,'location_description',null,'Location',7,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1105,'site_name',null,'Site',8,'site_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1104,'site0',null,'Original',8,'site_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (503,'trans_date',null,'Inventory',90000,'out_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1401,'current_depreciation',null,'vAssetDepreciation',27,'current_depreciation',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1003,'postal_code',null,'Supplier',9,'postal_code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (503,'customer_name',null,'Customer',4,'name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (401,'phone_number',null,'Supplier',4,null,'phone_number');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1101,'serial_number',null,'Inventory',11,'serial_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1001,'address1',null,'Supplier',9,'address1',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (10012,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (10012,'quantity',null,'Item',6,'qty_available',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1107,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1102,'trans_date',null,'Inventory',90000,'date_audited',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1003,'address1',null,'Supplier',9,'address1',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1204,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (803,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (702,'ref_number1','Invoice #','Invoice Pick',0,null,null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (702,'picked_quantity',null,'Invoice Pick',11,'quantity',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1107,'pallet',null,'Inventory',11,'pallet',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1107,'current_qty',null,'Inventory',13,'current_qty',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1107,'serial_number',null,'Inventory',11,'serial_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1501,'serial_number',null,'Inventory',11,'serial_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1401,'purchase_cost',null,'vAssetInfo',27,'purchase_cost',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (613,'site_name',null,'Site',8,'site_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (703,'customer_number',null,'Customer',4,'customer_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (10007,'original_data',null,'import_QB_errors',90000,'id_reference',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (10007,'error_number',null,'import_QB_errors',90000,'object_type',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (10007,'error_description',null,'import_QB_errors',90000,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1108,'site_name',null,'Site',8,'site_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1105,'lot',null,'Inventory',11,'lot',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1104,'site1',null,'Current',8,'site_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1002,'name',null,'Manufacturer',5,'name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1201,'purchase_cost',null,'vAssetInfo',27,'purchase_cost',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (609,'reason',null,'vAddInventory',1004,'reason',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (501,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1108,'date_code',null,'Inventory',11,'date_code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1107,'site_name',null,'Site',8,'site_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1003,'cphone','Cphone','Supplier',9,null,'Contact work phone');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1203,'purchase_date',null,'vAssetInfo',27,'purchase_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (703,'due_date',null,'Invoice Pick',22,'due_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1108,'site_name',null,'Site',8,'site_name',null);
GO
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (706,'customer_number',null,'Customer',4,'customer_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1108,'code',null,'Location',7,'code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1701,'end_date',null,'Contract',32,'end_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (504,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (501,'customer_email',null,'Customer',2,'email',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1501,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1003,'ccell','Cell Phone','Supplier',9,null,'Contact Cell Phone');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1504,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1302,'extension',null,'Supplier',90000,'extension',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (608,'employee_email',null,'Employee',2,'email',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1107,'date_code',null,'Inventory',11,'date_code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (706,'customer_name',null,'Customer',4,'name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (702,'due_date',null,'Invoice Pick',22,'due_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (701,'description',null,'Location',7,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1107,'date_code',null,'Inventory',11,'date_code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1107,'lot',null,'Inventory',11,'lot',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (504,'employee_phone_number',null,'Employee',2,'phone_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1201,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (702,'description',null,'Location',7,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1108,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1107,'trans_date',null,'Inventory',13,'trans_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1701,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (707,'customer_number',null,'Customer',4,'customer_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (607,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (605,'user_first_name',null,'User',90000,'user_first_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (607,'employee_extension',null,'Employee',90000,'extension',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (609,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (611,'serial_number',null,'Inventory',11,'serial_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (610,'moveto_location',null,'MoveTo',17,'location',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (610,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1002,'mail_stop',null,'Manufacturer',5,'mail_stop',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (508,'employee_number',null,'vCheckOutInfo',30,'employee_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1004,'department',null,'vUserSecurityInfo',4,'department',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1701,'description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (702,'customer_number',null,'Customer',4,'customer_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (508,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1001,'phone_number',null,'Supplier',9,null,'phone_number');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1003,'extension',null,'Supplier',9,null,'extension');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (509,'employee_number',null,'vCheckOutInfo',30,'employee_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1206,'serial_number',null,'Inventory',11,'serial_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1102,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1206,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1207,'purchase_cost',null,'vAssetInfo',27,'purchase_cost',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (802,'description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (10012,'due_date',null,'Item Receipt',22,'due_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1108,'pallet',null,'Inventory',11,'pallet',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1104,'description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1302,'last_name',null,'User',90000,'last_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (104,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1502,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1504,'first_name',null,'User',90000,'first_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (503,'customer_email',null,'Customer',2,'email',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (607,'user_first_name',null,'User',90000,'user_first_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (502,'customer_name',null,'Customer',4,'name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (502,'customer_phone_number',null,'Customer',2,'phone_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1107,'site_description',null,'Site',8,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (802,'qty',null,'Inventory',90000,'received_quantity',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (801,'quantity',null,'Item',6,'qty_available',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (801,'due_date',null,'Item Receive',22,'due_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1108,'trans_date',null,'Inventory',13,'trans_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1108,'location_description',null,'Location',7,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1104,'location1',null,'Current',7,'code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (701,'ref_number',null,'Invoice Pick',1001,'po',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1108,'code',null,'Location',7,'code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1105,'code',null,'Location',7,'code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1004,'last_name',null,'User',90000,'user_last_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1108,'current_qty',null,'Inventory',13,'current_qty',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1003,'phone_number','Phone Number','Supplier',9,null,null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1108,'lot',null,'Inventory',11,'lot',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1204,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1206,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1208,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (803,'due_date',null,'Item Receive',22,'due_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (702,'code',null,'Location',7,'code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1105,'serial_number',null,'Inventory',11,'serial_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1701,'internal_contact',null,'Contract',32,'internal_contact',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1701,'num_licenses',null,'Contract',32,'num_licenses',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1502,'schedule_date',null,'vAssetMaintenance',27,'schedule_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1003,'state',null,'Supplier',9,'state',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1301,'extension',null,'Supplier',90000,'extension',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1302,'department_name',null,'Department',90000,'department',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1102,'code',null,'Location',7,'code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1003,'name',null,'Supplier',9,'name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (605,'user_last_name',null,'User',90000,'user_last_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1003,'cextension',null,'Supplier',9,null,'Contact work phone extension');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (608,'user_last_name',null,'User',90000,'user_last_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (703,'location',null,'Location',7,'code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1105,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1105,'pallet',null,'Inventory',11,'pallet',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1203,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1003,'contact_name',null,'Supplier',9,'contact_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1204,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1207,'serial_number',null,'Inventory',11,'serial_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1207,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (803,'description',null,'Location',7,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (702,'site_name',null,'Site',8,'site_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1107,'quantity',null,'Inventory',11,'quantity',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1105,'location_description',null,'Location',7,'description',null);
GO
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1105,'date_code',null,'Inventory',11,'date_code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1701,'vendor_name',null,'Contract',32,'vendor_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (501,'customer_number',null,'Customer',4,'customer_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1208,'serial_number',null,'Inventory',11,'serial_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1208,'supplier_number',null,'Supplier',9,'supplier_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1003,'cfax',null,'Supplier',9,null,'Contact Fax');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1003,'city',null,'Supplier',9,'city',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1003,'country',null,'Supplier',9,'country',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (608,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1002,'phone_number',null,'Manufacturer',5,null,'phone_number');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1205,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1207,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1208,'purchase_cost',null,'vAssetInfo',27,'purchase_cost',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1302,'email',null,'Supplier',9,'email',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1503,'maint_date',null,'Maint',90000,'date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (504,'employee_last_name',null,'Employee',30,'last_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1107,'location_description',null,'Location',7,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (604,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (609,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (604,'user_last_name',null,'User',90000,'user_last_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (503,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (503,'date_acquired',null,'Inventory',90000,'due_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (502,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (504,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (502,'trans_date',null,'Inventory',90000,'out_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1701,'location',null,'Location',7,'code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1701,'site_name',null,'MoveFROM',8,'site_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (506,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (506,'customer_number',null,'Customer',4,'customer_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1204,'purchase_cost',null,'vAssetInfo',27,'purchase_cost',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1205,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1205,'site_name',null,'Site',8,'site_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1207,'purchase_date',null,'vAssetInfo',27,'purchase_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1210,'warranty_provider',null,'asset',27,'warranty_provider',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1401,'name',null,'Department',90000,'department',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1504,'serial_number',null,'Inventory',11,'serial_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1504,'last_name',null,'User',90000,'last_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1504,'site_name',null,'Site',8,'site_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1301,'employee_number',null,'vCheckOutInfo',30,'employee_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1301,'first_name',null,'User',90000,'first_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1302,'first_name',null,'User',90000,'first_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1303,'last_name',null,'Employee',90000,'last_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1303,'first_name',null,'Employee',90000,'first_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1303,'email',null,'Supplier',9,'email',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (104,'supplier_number',null,'Supplier',9,'supplier_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1201,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1401,'total_depreciation',null,'vAssetDepreciation',27,'total_depreciation',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1401,'last_depreciation_date',null,'vAssetDepreciation',27,'last_depreciation_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1501,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1504,'maint_date',null,'Maint',90000,'date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1503,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1503,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1503,'first_name',null,'User',90000,'first_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1503,'maint_complete',null,'Maint',90000,'status',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (502,'customer_number',null,'Customer',4,'customer_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (502,'customer_email',null,'Customer',2,'email',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (506,'customer_email',null,'Customer',2,'email',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (506,'customer_extension',null,'Customer',4,'extension',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (508,'date_acquired',null,'Inventory',90000,'due_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (508,'employee_last_name',null,'Employee',30,'last_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (508,'employee_first_name',null,'Employee',30,'first_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (508,'employee_email',null,'Employee',2,'email',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (508,'employee_phone_number',null,'Employee',2,'phone_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (507,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (507,'trans_date',null,'Inventory',90000,'out_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (507,'employee_number',null,'vCheckOutInfo',30,'employee_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (507,'employee_first_name',null,'Employee',30,'first_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (507,'employee_email',null,'Employee',2,'email',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (509,'trans_date',null,'Inventory',90000,'out_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (509,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (509,'employee_last_name',null,'Employee',30,'last_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (509,'employee_extension',null,'Employee',4,'extension',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (510,'employee_last_name',null,'Employee',30,'last_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (510,'employee_phone_number',null,'Employee',2,'phone_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (402,'name',null,'Supplier',9,'name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (402,'ccell',null,'Supplier',4,null,'Cell Phone');
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (402,'city',null,'Supplier',9,'city',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (402,'postal_code',null,'Supplier',9,'postal_code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (401,'address1',null,'Supplier',9,'address1',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1601,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1601,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1601,'trans_date',null,'Inventory',90000,'out_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1601,'date_acquired',null,'Inventory',90000,'due_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1601,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1601,'employee_first_name',null,'Employee',90000,'employee_first_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1601,'employee_email',null,'Employee',2,'email',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1601,'employee_phone_number',null,'Employee',2,'phone_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1601,'employee_extension',null,'Employee',90000,'extension',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1601,'purchase_cost',null,'vAssetInfo',27,'purchase_cost',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1602,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1602,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1602,'trans_date',null,'Inventory',90000,'out_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1602,'date_acquired',null,'Inventory',90000,'due_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1602,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1602,'employee_number',null,'vCheckOutInfo',30,'employee_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1602,'employee_last_name',null,'Employee',30,'last_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1602,'employee_first_name',null,'Employee',90000,'employee_first_name',null);
GO
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1602,'employee_email',null,'Employee',2,'email',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1602,'employee_phone_number',null,'Employee',2,'phone_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1602,'employee_extension',null,'Employee',90000,'extension',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1601,'employee_number',null,'vCheckOutInfo',30,'employee_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1603,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1603,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1603,'trans_date',null,'Inventory',90000,'out_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1603,'date_acquired',null,'Inventory',90000,'due_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1603,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1603,'employee_number',null,'vCheckOutInfo',30,'employee_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1603,'employee_last_name',null,'Employee',30,'last_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1603,'employee_first_name',null,'Employee',90000,'employee_first_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1603,'employee_email',null,'Employee',2,'email',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1603,'employee_phone_number',null,'Employee',2,'phone_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1603,'employee_extension',null,'Employee',90000,'extension',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1601,'employee_last_name',null,'Employee',30,'last_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1604,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1604,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1604,'trans_date',null,'Inventory',90000,'out_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1604,'date_acquired',null,'Inventory',90000,'due_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1604,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1604,'employee_number',null,'vCheckOutInfo',30,'employee_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1604,'employee_last_name',null,'Employee',30,'last_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1604,'employee_first_name',null,'Employee',90000,'employee_first_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1604,'employee_email',null,'Employee',2,'email',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1604,'employee_phone_number',null,'Employee',2,'phone_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1604,'employee_extension',null,'Employee',90000,'extension',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1605,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1605,'item_description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1605,'trans_date',null,'Inventory',90000,'out_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1605,'date_acquired',null,'Inventory',90000,'due_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1605,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1605,'employee_number',null,'vCheckOutInfo',30,'employee_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1605,'employee_last_name',null,'Employee',30,'last_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1605,'employee_first_name',null,'Employee',90000,'employee_first_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1605,'employee_email',null,'Employee',2,'email',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1605,'employee_phone_number',null,'Employee',2,'phone_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1605,'employee_extension',null,'Employee',90000,'extension',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1702,'num_licenses',null,'vContractInfo',32,'num_licenses',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1702,'vendor_name',null,'vContractInfo',32,'vendor_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1702,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1702,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1702,'description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1703,'contract_number',null,'vContractInfo',32,'contract_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1703,'contract_description',null,'vContractInfo',32,'contract_description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1703,'internal_contact',null,'vContractInfo',32,'internal_contact',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1703,'begin_date',null,'vContractInfo',32,'begin_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1703,'end_date',null,'vContractInfo',32,'end_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1703,'num_licenses',null,'vContractInfo',32,'num_licenses',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1703,'name',null,'Supplier',32,'vendor_name',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1220,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1220,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1220,'description',null,'Item',6,'description',null);
GO

INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (610,'trans_date',null,'Entry',90000,'transaction_date',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (610,'trans_type',null,'Entry',90000,'type',null);

INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1202,'location',null,'location',7,'code',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1202,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1202,'file_data',null,'File',0,'',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1202,'supplier_number',null,'Supplier',9,'supplier_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1202,'vendor',null,'vAssetPictures',6,'vendor',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1202,'serial_number',null,'Inventory',11,'serial_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1202,'manufacturer',null,'vItemSummary',27,'manufacturer',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1202,'model',null,'vAssetPictures',6,'model',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1202,'item_number',null,'Item',6,'item_number',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1202,'description',null,'Item',6,'description',null);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1202,'manufacturer',null,'vItemSummary',27,'manufacturer',null);


delete report_labels where rpt_id=1103
insert into report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1103,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null);
insert into report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1103,'item_number',null,'Item',6,'item_number',null);
insert into report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1103,'item_description',null,'Item',6,'description',null);
insert into report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1103,'location',null,'Location',7,'code',null);
insert into report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1103,'serial_number',null,'Inventory',11,'serial_number',null);
insert into report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1103,'site_name',null,'MoveFrom',8,'site_name',null);
insert into report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1103,'is_checked_out',null,'vAssetInfo',27,'is_checked_out',null);
insert into report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field) values (1103,'last_audit_date',null,'vAssetAudit',90000,'last_audit_date',null);


----------------------------------------------------
-- Table Name: report_names
----------------------------------------------------
DELETE FROM report_names

INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (103,1,-1,'Item Reorder Report','Item Reorder Report','Item Reorder Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (105,1,-5,'Items by Category Report','Items by Category Report','Items by Category Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (107,1,-7,'Items by Vendor Report ','Items by Vendor Report','Items by Vendor Report ','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (1204,12,4,'Assets by Asset Type Report','Assets By Asset Type Report','Assets by Asset Type Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (1205,12,5,'Assets by Location Report','Assets By Location Report','Assets by Location Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (1208,12,8,'Assets by Vendor Report','Assets By Vendor Report','Assets by Vendor Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (301,3,1,'Location List Report','Location List Report','Location List Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (401,4,1,'Customers by Number Report','Customers By ID Report','Customers by Number Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (402,4,2,'Customers by Name Report','Customers By Name Report','Customers by Name Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (403,4,3,'Customers by Postal Code Report','Customers By Postal Code Report','Customers by Postal Code Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (502,5,4,'Check-Out to Customer by Due Date Report','Customer Check-out By Due Date Report','Check-Out to Customer by Due Date Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (503,5,3,'Check-Out to Customer by Asset Tag Report','Customer Check-out By Asset Tag Report','Check-Out to Customer by Asset Tag Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (1601,16,1,'Check-Out to Employee Report','Check-out By Employee Report','Check-Out to Employee Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (505,5,5,'Check-Out to Customer Due Today Report','Customer Check-out Due Today Report','Check-Out to Customer Due Today Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (506,5,6,'Check-Out to Customer Past Due Report','Customer Check-out Past Due Report','Check-Out to Customer Past Due Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (1401,14,1,'Asset Depreciation by Department Report','Asset Depreciation By Department Report','Asset Depreciation by Department Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (1210,12,10,'Asset Warranty Information Report','Asset Warranty Information Report','Asset Warranty Information Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (1102,11,2,'Asset Audit History by Date Report','Asset Audit History By Date Report','Asset Audit History by Date Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (605,6,2,'Transaction Check-In by Customer Report','Transaction Check-in By Customer Report','Transaction Check-In by Customer Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (609,6,6,'Transaction Dispose Report','Transaction Dispose Report','Transaction Dispose Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (610,6,8,'Transaction History Report','Transaction History Report','Transaction History Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (611,6,7,'Transaction Move Report','Transaction Move Report','Transaction Move Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (613,6,1,'Transaction Add Report','Transaction Add Report','Transaction Add Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (701,7,-1,'Line Item Pick Ticket','Line Item Pick Ticket','Line Item Pick Ticket','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (20006,20000,-2,'Asset History Report','Transaction History Receipt','Asset History Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (20003,20000,null,'Asset Check-Out Receipt','Asset Check-out Receipt','Asset Check-Out Receipt','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (20001,20000,null,'Asset Audit Receipt','Asset Audit Receipt','Asset Audit Receipt','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (1504,15,3,'Asset Maintenance History by Asset Tag Report','Asset Maintenance History By Asset Tag Report','Asset Maintenance History by Asset Tag Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (801,8,-1,'Item Receive Ticket','Item Receive Report','Item Receive Ticket','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (1004,10,4,'User Security Option Report','User Security Option Report','User Security Option Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (10009,10000,null,'Line Item Pick Receipt','Line Item Pick Receipt','Line Item Pick Receipt','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (10007,10000,null,'Import FROM QB Error Report','Import FROM QB Error Report','Import FROM QB Error Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (1101,11,1,'Asset Audit History by Asset Tag Report','Asset Audit History By Asset Tag Report','Asset Audit History by Asset Tag Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (604,6,3,'Transaction Check-out by Customer Report','Transaction Check-out By Customer Report','Transaction Check-out by Customer Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (1203,12,3,'Assets by Category Report','Assets By Category Report','Assets by Category Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (1206,12,6,'Assets by Manufacturer Report','Assets By Manufacturer Report','Assets by Manufacturer Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (1207,12,7,'Assets by PO Report','Assets By PO Report','Assets by PO Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (1301,13,1,'Employees by Name Report','Employees by Name Report','Employees by Name Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (1302,13,2,'Employees by Department Report','Employees by Department Report','Employees by Department Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (104,1,4,'Asset Types Report','Asset Types Report','Asset Types Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (106,1,-6,'Items by Manufacturer Report','Items by Manufacturer Report','Items by Manufacturer Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (404,4,4,'Customers by State Report','Customers By State Report','Customers by State Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (501,5,1,'Check-Out to Customer Report','Check-out By Customer Report','Check-Out to Customer Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (20005,20000,-1,'Asset Maintenance History Report','Asset Maintenance History By Asset Tag Receipt','Asset Maintenance History Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (1503,15,4,'Asset Maintenance History by Date Report','Asset Maintenance History By Date Report','Asset Maintenance History by Date Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (20002,20000,null,'Asset Check-In Receipt','Asset Check-in By Customer Receipt','Asset Check-In Receipt','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (10001,10000,null,'Inventory Adjust Receipt','Inventory Adjust Receipt','Inventory Adjust Receipt','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (10002,10000,null,'Inventory Check-In Receipt','Inventory Check-in Receipt','Inventory Check-In Receipt','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (10003,10000,null,'Inventory Check-Out Receipt','Inventory Check-out Receipt','Inventory Check-Out Receipt','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (10004,10000,null,'Inventory Move Receipt','Inventory Move Receipt','Inventory Move Receipt','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (10005,10000,null,'Inventory Add Receipt','Inventory Add Receipt','Inventory Add Receipt','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (10006,10000,null,'Inventory Remove Receipt','Inventory Remove Receipt','Inventory Remove Receipt','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (10008,10000,null,'Import-Export Error Report','Import-Export Error Report','Import-Export Error Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (10010,10000,null,'Item Receipt','Item Receive Receipt','Item Receipt','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (805,8,-5,'Credit Memo','Item Receive Receipt (All)','Credit Memo','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (708,7,-8,'Line Item Pick Ticket','Line Item Pick Ticket with Bar Codes','Line Item Pick Ticket','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (10011,10000,null,'Line Item Post Pick Report','Line Item Pick Receipt (All)','Line Item Post Pick Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (10012,10000,null,'Item Receipt','Item Receive Receipt (All)','Item Receipt','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (1001,10,3,'Vendors by Name Report','Vendors By Name Report','Vendors by Name Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (1002,10,2,'Manufacturers by Name Report','Manufacturers By Name Report','Manufacturers by Name Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (1303,13,3,'Employees by Manager Report','Employees by Manager Report','Employees by Manager Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (1201,12,1,'Assets by Asset Tag Report','Assets By Asset Tag Report','Assets by Asset Tag Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (1202,12,2,'Assets by Asset Tag With Picture Report','Assets By Asset Tag With Picture Report','Assets by Asset Tag With Picture Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (1501,15,1,'Maintenance Schedule by Asset Report','Maintenance Schedule By Asset Report','Maintenance Schedule by Asset Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (1005,10,5,'Browse...','Browse...','Browse...','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (1502,15,2,'Maintenance Schedule by Assigned To Report','Maintenance Schedule By Assigned To Report','Maintenance Schedule by Assigned To Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (607,6,4,'Transaction Check-In by Employee Report','Transaction Check-in By Employee Report','Transaction Check-In by Employee Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (608,6,5,'Transaction Check-Out by Employee Report','Transaction Check-out By Employee Report','Transaction Check-Out by Employee Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (20004,20000,null,'Asset Check-In Receipt','Asset Check-in By Employee Receipt','Asset Check-In Receipt','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (1603,16,3,'Check-Out To Employee by Due Date Report','Employee Check-out By Due Date Report','Check-Out To Employee by Due Date Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (1602,16,2,'Check-Out To Employee by Asset Tag Report','Employee Check-out By Asset Tag Report','Check-Out To Employee by Asset Tag Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (1604,16,4,'Check-Out To Employee Due Today Report','Employee Check-out Due Today Report','Check-Out To Employee Due Today Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (1605,16,5,'Check-Out To Employee Past Due Report','Employee Check-out Past Due Report','Check-Out To Employee Past Due Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (20007,20000,-7,'Employee Transaction Report','Employee Transaction Report','Employee Transaction Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (1220,12,20,'Asset Links Report','Asset Links Report','Asset Links Report','f','f',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (1701,17,1,'Contracts Report','Contracts Report','Contracts Report','f','f',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (1702,17,2,'Contracts By Asset Report','Contracts By Asset Report','Contracts By Asset Report','f','f',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (1703,17,3,'Software License Report','Software License Report','Software License Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (1103,11,3,'Not Audited Assets Report','Not Audited Assets Report','Not Audited Assets Report','F','F',null);
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips) values (1104,11,4,'Assets Audit Location Discrepancy Report','Assets Audit Location Discrepancy Report','Assets Audit Location Discrepancy Report','F','F',null);
GO




update form_field_meta set label = '&Asset Type:', tool_tip = 'Enter asset type id in this field. Asset type must be unique.', default_label = '&Asset Type:', default_tool_tip= 'Enter asset type id in this field. Asset type must be unique.' WHERE form_id = 6 and control = 'label' and field = 'item_number'

GO

INSERT INTO user_privileges 
SELECT DISTINCT user_id, 'add' AS Expr2, 1 AS Expr1 
FROM USERS WHERE user_id not in (select user_id from user_privileges where security_code = 'add') and user_id > 1

if EXISTS (SELECT * FROM dbo.sysindexes WHERE NAME = N'IX_USERS_LOGON')
BEGIN
   DROP INDEX [dbo].[users].[IX_USER_LOGON] 
END

IF EXISTS (SELECT security_code FROM dbo.security_privileges WHERE security_code = 'lists') 
BEGIN
   UPDATE security_privileges SET company_id = 2 WHERE security_code = 'lists';
   UPDATE user_privileges SET record_status = 2 WHERE security_code = 'lists' 
END


IF NOT EXISTS (select security_code FROM dbo.security_privileges WHERE security_code = 'edit')
BEGIN
   INSERT INTO security_privileges VALUES ('edit', 'Edit Asset', 1)

   INSERT INTO user_privileges (user_id, security_code, record_status) 
      SELECT DISTINCT user_id, 'edit', 1 FROM users WHERE user_id > 0 and record_status = 1 and company_id = 1
END


GO

DELETE FROM ui_settings
WHERE setting_name in ('AssetListDlg', 'ClassListDlg')

GO

--------------------------------------------------------
-- This is to fix the problem described in bug #13552
-- There had been change made to send down data based 
-- on date_updated. But Since triggers were not set up 
-- properly initially, there are records with null
-- date_updated....CY
--------------------------------------------------------


DELETE FROM mobile_data_snapshot

UPDATE    item
SET       date_updated = GETDATE()
WHERE     (date_updated is NULL)

UPDATE    users
SET       date_updated = GETDATE()
WHERE     (date_updated is NULL)

UPDATE    location
SET       date_updated = GETDATE()
WHERE     (date_updated is NULL)

UPDATE    sites
SET       date_updated = GETDATE()
WHERE     (date_updated is NULL)

UPDATE    manufacturer
SET       date_updated = GETDATE()
WHERE     (date_updated is NULL)

UPDATE    employees
SET       date_updated = GETDATE()
WHERE     (date_updated is NULL)

UPDATE    customer
SET       date_updated = GETDATE()
WHERE     (date_updated is NULL)

UPDATE    asset
SET       date_updated = GETDATE()
WHERE     (date_updated is NULL)

GO


-------------------------------------------
-- Rebuild indexes so to prevent the database 
-- from growing too much in fragmentation
-- and negatively impacts performance
-------------------------------------------

USE wasptrackasset 

DECLARE @TableName varchar(255) 
DECLARE TableCursor CURSOR FOR 

SELECT table_name FROM information_schema.tables 
WHERE table_type = 'base table' 

OPEN TableCursor 

FETCH NEXT FROM TableCursor INTO @TableName 

WHILE @@FETCH_STATUS = 0 
BEGIN 

DBCC DBREINDEX(@TableName,' ',90) 
FETCH NEXT FROM TableCursor INTO @TableName 

END 

CLOSE TableCursor 
DEALLOCATE TableCursor


GO

